;;  Horn Clause Representation of Mairasi Kinship Term-of-Reference Rules

;;  The following 'header' gives some basic parameters of this kinship system:
(languageName, "Mairasi") (author, "Nancy Peckham") (date, "1983-01-01") (citation, "Nancy Peckham in GODS, HEROES, KINSMEN pp. 255-270") 
(non_term, [aux], brother, children, half_brother, half_sister, parents, sibling, siblings, sister, spice, step_brother, step_daughter, step_father, step_mother, step_sister, step_son) (partial, false) (polygamyOK, true) (address, false) (recursiveLevels, 2)
(overlaps, (a_a, (josiri)), (fovo_naiwo, (fovo_navwer)), (fovo_navwer, (fovo_naiwo)), (ina_naiwo, (ina_navwer)), (ina_navwer, (ina_naiwo)), (josiri, (a_a)), (mem_naiwo, (mem_navwer)), (mem_navwer, (mem_naiwo)), (nani_naiwo, (nani_navwer)), (nani_navwer, (nani_naiwo)))


;;  Kin Term Definitions:
;;	(Standard Macros are automatically incorporated.)

a_a(Alter, Ego) :-  siblings(Alter, Ego), elder(Alter, Ego).
                |  [ext],  parents(A, Ego), generation[aux]27senior_gs(B, A), children(Alter, B).
{"Bro_FaBroDa_FaBroSo_FaFaBroDaDa_FaFaBroDaSo_FaFaBroSoDa_FaFaBroSoSo_FaFaFaBroDaDaDa_FaFaFaBroDaDaSo_FaFaFaBroDaSoDa_FaFaFaBroDaSoSo_FaFaFaBroSoDaDa_FaFaFaBroSoDaSo_FaFaFaBroSoSoDa_FaFaFaBroSoSoSo_FaFaFaSisDaDaDa_FaFaFaSisDaDaSo_FaFaFaSisDaSoDa_FaFaFaSisDaSoSo_FaFaFaSisSoDaDa_FaFaFaSisSoDaSo_FaFaFaSisSoSoDa_FaFaFaSisSoSoSo_FaFaMoBroDaDaDa_FaFaMoBroDaDaSo_FaFaMoBroDaSoDa_FaFaMoBroDaSoSo_FaFaMoBroSoDaDa_FaFaMoBroSoDaSo_FaFaMoBroSoSoDa_FaFaMoBroSoSoSo_FaFaMoSisDaDaDa_FaFaMoSisDaDaSo_FaFaMoSisDaSoDa_FaFaMoSisDaSoSo_FaFaMoSisSoDaDa_FaFaMoSisSoDaSo_FaFaMoSisSoSoDa_FaFaMoSisSoSoSo_FaFaSisDaDa_FaFaSisDaSo_FaFaSisSoDa_FaFaSisSoSo_FaMoBroDaDa_FaMoBroDaSo_FaMoBroSoDa_FaMoBroSoSo_FaMoFaBroDaDaDa_FaMoFaBroDaDaSo_FaMoFaBroDaSoDa_FaMoFaBroDaSoSo_FaMoFaBroSoDaDa_FaMoFaBroSoDaSo_FaMoFaBroSoSoDa_FaMoFaBroSoSoSo_FaMoFaSisDaDaDa_FaMoFaSisDaDaSo_FaMoFaSisDaSoDa_FaMoFaSisDaSoSo_FaMoFaSisSoDaDa_FaMoFaSisSoDaSo_FaMoFaSisSoSoDa_FaMoFaSisSoSoSo_FaMoMoBroDaDaDa_FaMoMoBroDaDaSo_FaMoMoBroDaSoDa_FaMoMoBroDaSoSo_FaMoMoBroSoDaDa_FaMoMoBroSoDaSo_FaMoMoBroSoSoDa_FaMoMoBroSoSoSo_FaMoMoSisDaDaDa_FaMoMoSisDaDaSo_FaMoMoSisDaSoDa_FaMoMoSisDaSoSo_FaMoMoSisSoDaDa_FaMoMoSisSoDaSo_FaMoMoSisSoSoDa_FaMoMoSisSoSoSo_FaMoSisDaDa_FaMoSisDaSo_FaMoSisSoDa_FaMoSisSoSo_FaSisDa_FaSisSo_MoBroDa_MoBroSo_MoFaBroDaDa_MoFaBroDaSo_MoFaBroSoDa_MoFaBroSoSo_MoFaFaBroDaDaDa_MoFaFaBroDaDaSo_MoFaFaBroDaSoDa_MoFaFaBroDaSoSo_MoFaFaBroSoDaDa_MoFaFaBroSoDaSo_MoFaFaBroSoSoDa_MoFaFaBroSoSoSo_MoFaFaSisDaDaDa_MoFaFaSisDaDaSo_MoFaFaSisDaSoDa_MoFaFaSisDaSoSo_MoFaFaSisSoDaDa_MoFaFaSisSoDaSo_MoFaFaSisSoSoDa_MoFaFaSisSoSoSo_MoFaMoBroDaDaDa_MoFaMoBroDaDaSo_MoFaMoBroDaSoDa_MoFaMoBroDaSoSo_MoFaMoBroSoDaDa_MoFaMoBroSoDaSo_MoFaMoBroSoSoDa_MoFaMoBroSoSoSo_MoFaMoSisDaDaDa_MoFaMoSisDaDaSo_MoFaMoSisDaSoDa_MoFaMoSisDaSoSo_MoFaMoSisSoDaDa_MoFaMoSisSoDaSo_MoFaMoSisSoSoDa_MoFaMoSisSoSoSo_MoFaSisDaDa_MoFaSisDaSo_MoFaSisSoDa_MoFaSisSoSo_MoMoBroDaDa_MoMoBroDaSo_MoMoBroSoDa_MoMoBroSoSo_MoMoFaBroDaDaDa_MoMoFaBroDaDaSo_MoMoFaBroDaSoDa_MoMoFaBroDaSoSo_MoMoFaBroSoDaDa_MoMoFaBroSoDaSo_MoMoFaBroSoSoDa_MoMoFaBroSoSoSo_MoMoFaSisDaDaDa_MoMoFaSisDaDaSo_MoMoFaSisDaSoDa_MoMoFaSisDaSoSo_MoMoFaSisSoDaDa_MoMoFaSisSoDaSo_MoMoFaSisSoSoDa_MoMoFaSisSoSoSo_MoMoMoBroDaDaDa_MoMoMoBroDaDaSo_MoMoMoBroDaSoDa_MoMoMoBroDaSoSo_MoMoMoBroSoDaDa_MoMoMoBroSoDaSo_MoMoMoBroSoSoDa_MoMoMoBroSoSoSo_MoMoMoSisDaDaDa_MoMoMoSisDaDaSo_MoMoMoSisDaSoDa_MoMoMoSisDaSoSo_MoMoMoSisSoDaDa_MoMoMoSisSoDaSo_MoMoMoSisSoSoDa_MoMoMoSisSoSoSo_MoMoSisDaDa_MoMoSisDaSo_MoMoSisSoDa_MoMoSisSoSo_MoSisDa_MoSisSo_Sis"}
;; 0
%a_a:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Bro}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), elder(Alter, Ego).
;; 1
%a_a:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), elder(Alter, Ego).
;; 2
%a_a:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), son(Alter, D).
;; 3
%a_a:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), daughter(Alter, D).
;; 4
%a_a:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), son(Alter, D).
;; 5
%a_a:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), daughter(Alter, D).
;; 6
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 7
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 8
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 9
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 10
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 11
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 12
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 13
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 14
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 15
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 16
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 17
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 18
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 19
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 20
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 21
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 22
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 23
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 24
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 25
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 26
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 27
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 28
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 29
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 30
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 31
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 32
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 33
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 34
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 35
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 36
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 37
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 38
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 39
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 40
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 41
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 42
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 43
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 44
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 45
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 46
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 47
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 48
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 49
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 50
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 51
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 52
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 53
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 54
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 55
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 56
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 57
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 58
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 59
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 60
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 61
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 62
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 63
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 64
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 65
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 66
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 67
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 68
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 69
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 70
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 71
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 72
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 73
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 74
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 75
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 76
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 77
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 78
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 79
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 80
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 81
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 82
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 83
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 84
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 85
%a_a:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 86
%a_a:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), son(Alter, D).
;; 87
%a_a:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), daughter(Alter, D).
;; 88
%a_a:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), son(Alter, D).
;; 89
%a_a:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), daughter(Alter, D).
;; 90
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 91
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 92
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 93
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 94
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 95
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 96
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 97
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 98
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 99
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 100
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 101
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 102
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 103
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 104
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 105
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 106
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 107
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 108
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 109
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 110
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 111
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 112
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 113
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 114
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 115
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 116
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 117
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 118
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 119
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 120
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 121
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 122
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 123
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 124
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 125
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 126
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 127
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 128
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 129
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 130
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 131
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 132
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 133
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 134
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 135
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 136
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 137
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 138
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 139
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 140
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 141
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 142
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 143
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 144
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 145
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 146
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 147
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 148
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 149
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 150
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 151
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 152
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 153
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 154
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 155
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 156
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 157
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 158
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 159
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 160
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 161
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 162
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), son(Alter, H).
;; 163
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 164
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 165
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 166
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 167
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 168
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 169
%a_a:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).


avo(Alter, Ego) :-  avo[aux]27(Alter, Ego).
                |   avo[aux]27(Ego, Alter).
                |  [ext],  avo[aux]27(A, Ego), spouse(Alter, A).
                |  [ext],  spouse(A, Ego), avo[aux]27(Alter, A).
{"BroDaDa_BroDaSo_BroSoDa_BroSoSo_DaDa_DaSo_FaBroDaDaDa_FaBroDaDaSo_FaBroDaSoDa_FaBroDaSoSo_FaBroSoDaDa_FaBroSoDaSo_FaBroSoSoDa_FaBroSoSoSo_FaFa_FaFaBro_FaFaBroWi_FaFaFaBroDa_FaFaFaBroDaHu_FaFaFaBroSo_FaFaFaBroSoWi_FaFaFaSisDa_FaFaFaSisDaHu_FaFaFaSisSo_FaFaFaSisSoWi_FaFaMoBroDa_FaFaMoBroDaHu_FaFaMoBroSo_FaFaMoBroSoWi_FaFaMoSisDa_FaFaMoSisDaHu_FaFaMoSisSo_FaFaMoSisSoWi_FaFaSis_FaFaSisHu_FaMo_FaMoBro_FaMoBroWi_FaMoFaBroDa_FaMoFaBroDaHu_FaMoFaBroSo_FaMoFaBroSoWi_FaMoFaSisDa_FaMoFaSisDaHu_FaMoFaSisSo_FaMoFaSisSoWi_FaMoMoBroDa_FaMoMoBroDaHu_FaMoMoBroSo_FaMoMoBroSoWi_FaMoMoSisDa_FaMoMoSisDaHu_FaMoMoSisSo_FaMoMoSisSoWi_FaMoSis_FaMoSisHu_FaSisDaDaDa_FaSisDaDaSo_FaSisDaSoDa_FaSisDaSoSo_FaSisSoDaDa_FaSisSoDaSo_FaSisSoSoDa_FaSisSoSoSo_HuFaFa_HuFaFaBro_HuFaFaFaBroDa_HuFaFaFaBroSo_HuFaFaFaSisDa_HuFaFaFaSisSo_HuFaFaMoBroDa_HuFaFaMoBroSo_HuFaFaMoSisDa_HuFaFaMoSisSo_HuFaFaSis_HuFaMo_HuFaMoBro_HuFaMoFaBroDa_HuFaMoFaBroSo_HuFaMoFaSisDa_HuFaMoFaSisSo_HuFaMoMoBroDa_HuFaMoMoBroSo_HuFaMoMoSisDa_HuFaMoMoSisSo_HuFaMoSis_HuMoFa_HuMoFaBro_HuMoFaFaBroDa_HuMoFaFaBroSo_HuMoFaFaSisDa_HuMoFaFaSisSo_HuMoFaMoBroDa_HuMoFaMoBroSo_HuMoFaMoSisDa_HuMoFaMoSisSo_HuMoFaSis_HuMoMo_HuMoMoBro_HuMoMoFaBroDa_HuMoMoFaBroSo_HuMoMoFaSisDa_HuMoMoFaSisSo_HuMoMoMoBroDa_HuMoMoMoBroSo_HuMoMoMoSisDa_HuMoMoMoSisSo_HuMoMoSis_MoBroDaDaDa_MoBroDaDaSo_MoBroDaSoDa_MoBroDaSoSo_MoBroSoDaDa_MoBroSoDaSo_MoBroSoSoDa_MoBroSoSoSo_MoFa_MoFaBro_MoFaBroWi_MoFaFaBroDa_MoFaFaBroDaHu_MoFaFaBroSo_MoFaFaBroSoWi_MoFaFaSisDa_MoFaFaSisDaHu_MoFaFaSisSo_MoFaFaSisSoWi_MoFaMoBroDa_MoFaMoBroDaHu_MoFaMoBroSo_MoFaMoBroSoWi_MoFaMoSisDa_MoFaMoSisDaHu_MoFaMoSisSo_MoFaMoSisSoWi_MoFaSis_MoFaSisHu_MoMo_MoMoBro_MoMoBroWi_MoMoFaBroDa_MoMoFaBroDaHu_MoMoFaBroSo_MoMoFaBroSoWi_MoMoFaSisDa_MoMoFaSisDaHu_MoMoFaSisSo_MoMoFaSisSoWi_MoMoMoBroDa_MoMoMoBroDaHu_MoMoMoBroSo_MoMoMoBroSoWi_MoMoMoSisDa_MoMoMoSisDaHu_MoMoMoSisSo_MoMoMoSisSoWi_MoMoSis_MoMoSisHu_MoSisDaDaDa_MoSisDaDaSo_MoSisDaSoDa_MoSisDaSoSo_MoSisSoDaDa_MoSisSoDaSo_MoSisSoSoDa_MoSisSoSoSo_SisDaDa_SisDaSo_SisSoDa_SisSoSo_SoDa_SoSo_WiFaFa_WiFaFaBro_WiFaFaFaBroDa_WiFaFaFaBroSo_WiFaFaFaSisDa_WiFaFaFaSisSo_WiFaFaMoBroDa_WiFaFaMoBroSo_WiFaFaMoSisDa_WiFaFaMoSisSo_WiFaFaSis_WiFaMo_WiFaMoBro_WiFaMoFaBroDa_WiFaMoFaBroSo_WiFaMoFaSisDa_WiFaMoFaSisSo_WiFaMoMoBroDa_WiFaMoMoBroSo_WiFaMoMoSisDa_WiFaMoMoSisSo_WiFaMoSis_WiMoFa_WiMoFaBro_WiMoFaFaBroDa_WiMoFaFaBroSo_WiMoFaFaSisDa_WiMoFaFaSisSo_WiMoFaMoBroDa_WiMoFaMoBroSo_WiMoFaMoSisDa_WiMoFaMoSisSo_WiMoFaSis_WiMoMo_WiMoMoBro_WiMoMoFaBroDa_WiMoMoFaBroSo_WiMoMoFaSisDa_WiMoMoFaSisSo_WiMoMoMoBroDa_WiMoMoMoBroSo_WiMoMoMoSisDa_WiMoMoMoSisSo_WiMoMoSis"}
;; 0
%avo:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {MoMo}  
 male(Ego), mother(A, Ego), mother(Alter, A).
;; 1
%avo:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {MoFa}  
 male(Ego), mother(A, Ego), father(Alter, A).
;; 2
%avo:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {FaMo}  
 male(Ego), father(A, Ego), mother(Alter, A).
;; 3
%avo:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {FaFa}  
 male(Ego), father(A, Ego), father(Alter, A).
;; 4
%avo:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {MoMo}  
 female(Ego), mother(A, Ego), mother(Alter, A).
;; 5
%avo:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {MoFa}  
 female(Ego), mother(A, Ego), father(Alter, A).
;; 6
%avo:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=2,  PC=2, S=0, Star=0,  {FaMo}  
 female(Ego), father(A, Ego), mother(Alter, A).
;; 7
%avo:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=2,  PC=2, S=0, Star=0,  {FaFa}  
 female(Ego), father(A, Ego), father(Alter, A).
;; 8
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoMoBro}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 9
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoMoSis}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 10
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoBroSo}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 11
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoBroDa}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 12
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoSisSo}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 13
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoSisDa}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 14
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaBroSo}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 15
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaBroDa}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 16
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaSisSo}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 17
%avo:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaSisDa}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 18
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoFaBro}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 19
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoFaSis}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 20
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoBroSo}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 21
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoBroDa}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 22
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoSisSo}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 23
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoSisDa}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 24
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaBroSo}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 25
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaBroDa}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 26
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaSisSo}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 27
%avo:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaSisDa}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 28
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaMoBro}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 29
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaMoSis}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 30
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoBroSo}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 31
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoBroDa}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 32
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoSisSo}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 33
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoSisDa}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 34
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaBroSo}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 35
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaBroDa}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 36
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaSisSo}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 37
%avo:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaSisDa}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 38
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaFaBro}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 39
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaFaSis}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 40
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoBroSo}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 41
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoBroDa}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 42
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoSisSo}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 43
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoSisDa}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 44
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaBroSo}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 45
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaBroDa}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 46
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaSisSo}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 47
%avo:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaSisDa}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 48
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoMoBro}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 49
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoMoSis}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 50
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoBroSo}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 51
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoBroDa}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 52
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoSisSo}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 53
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoMoSisDa}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 54
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaBroSo}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 55
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaBroDa}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 56
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaSisSo}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 57
%avo:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoMoFaSisDa}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 58
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoFaBro}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 59
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {MoFaSis}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 60
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoBroSo}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 61
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoBroDa}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 62
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoSisSo}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 63
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaMoSisDa}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 64
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaBroSo}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 65
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaBroDa}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 66
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaSisSo}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 67
%avo:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {MoFaFaSisDa}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 68
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaMoBro}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 69
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaMoSis}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 70
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoBroSo}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 71
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoBroDa}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 72
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoSisSo}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 73
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoMoSisDa}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 74
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaBroSo}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 75
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaBroDa}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 76
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaSisSo}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 77
%avo:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaMoFaSisDa}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 78
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaFaBro}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 79
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=0, Star=0,  {FaFaSis}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 80
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoBroSo}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 81
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoBroDa}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 82
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoSisSo}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 83
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaMoSisDa}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 84
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaBroSo}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 85
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaBroDa}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 86
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaSisSo}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 87
%avo:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=0, Star=0,  {FaFaFaSisDa}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 88
%avo:1, avo[aux]27:0, parents:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {DaSo}  
 male(Alter), mother(A, Alter), mother(Ego, A).
;; 89
%avo:1, avo[aux]27:0, parents:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {DaSo}  
 male(Alter), mother(A, Alter), father(Ego, A).
;; 90
%avo:1, avo[aux]27:0, parents:1, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {SoSo}  
 male(Alter), father(A, Alter), mother(Ego, A).
;; 91
%avo:1, avo[aux]27:0, parents:1, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {SoSo}  
 male(Alter), father(A, Alter), father(Ego, A).
;; 92
%avo:1, avo[aux]27:1, parents:0, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {DaDa}  
 female(Alter), mother(A, Alter), mother(Ego, A).
;; 93
%avo:1, avo[aux]27:1, parents:0, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {DaDa}  
 female(Alter), mother(A, Alter), father(Ego, A).
;; 94
%avo:1, avo[aux]27:1, parents:1, parents:0%
 Lvl=-2,  PC=2, S=0, Star=0,  {SoDa}  
 female(Alter), father(A, Alter), mother(Ego, A).
;; 95
%avo:1, avo[aux]27:1, parents:1, parents:1%
 Lvl=-2,  PC=2, S=0, Star=0,  {SoDa}  
 female(Alter), father(A, Alter), father(Ego, A).
;; 96
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 97
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 98
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 99
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 100
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 101
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 102
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 103
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 104
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 105
%avo:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 106
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 107
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 108
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 109
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 110
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 111
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 112
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 113
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 114
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 115
%avo:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 116
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 117
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 118
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 119
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 120
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 121
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 122
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 123
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 124
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 125
%avo:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 126
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 127
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 128
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 129
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 130
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 131
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 132
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 133
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 134
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 135
%avo:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 136
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 137
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 138
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 139
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 140
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 141
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 142
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 143
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 144
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 145
%avo:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaDaDa}  
[ext],  female(Alter), mother(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 146
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 147
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 148
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 149
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 150
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 151
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 152
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 153
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 154
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 155
%avo:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoDaDa}  
[ext],  female(Alter), mother(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 156
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 157
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {SisSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 158
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 159
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 160
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 161
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 162
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 163
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 164
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 165
%avo:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroDaSoDa}  
[ext],  female(Alter), father(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 166
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 167
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-2,  PC=6, S=0, Star=0,  {BroSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 168
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 169
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaSisSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 170
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 171
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoSisSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 172
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 173
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {FaBroSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 174
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 175
%avo:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-2,  PC=8, S=0, Star=0,  {MoBroSoSoDa}  
[ext],  female(Alter), father(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 176
%avo:2, avo[aux]27:0, parents:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {MoFa}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), spouse(Alter, B).
;; 177
%avo:2, avo[aux]27:0, parents:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {MoMo}  
[ext],  male(Ego), mother(A, Ego), father(B, A), spouse(Alter, B).
;; 178
%avo:2, avo[aux]27:0, parents:1, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {FaFa}  
[ext],  male(Ego), father(A, Ego), mother(B, A), spouse(Alter, B).
;; 179
%avo:2, avo[aux]27:0, parents:1, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {FaMo}  
[ext],  male(Ego), father(A, Ego), father(B, A), spouse(Alter, B).
;; 180
%avo:2, avo[aux]27:1, parents:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {MoFa}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), spouse(Alter, B).
;; 181
%avo:2, avo[aux]27:1, parents:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {MoMo}  
[ext],  female(Ego), mother(A, Ego), father(B, A), spouse(Alter, B).
;; 182
%avo:2, avo[aux]27:1, parents:1, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {FaFa}  
[ext],  female(Ego), father(A, Ego), mother(B, A), spouse(Alter, B).
;; 183
%avo:2, avo[aux]27:1, parents:1, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {FaMo}  
[ext],  female(Ego), father(A, Ego), father(B, A), spouse(Alter, B).
;; 184
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoMoBroWi}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 185
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoMoSisHu}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 186
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoBroSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 187
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoBroDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 188
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoSisSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 189
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoSisDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 190
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaBroSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 191
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaBroDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 192
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaSisSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 193
%avo:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaSisDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 194
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoFaBroWi}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 195
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoFaSisHu}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 196
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoBroSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 197
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoBroDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 198
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoSisSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 199
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoSisDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 200
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaBroSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 201
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaBroDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 202
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaSisSoWi}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 203
%avo:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaSisDaHu}  
[ext], [ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 204
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaMoBroWi}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 205
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaMoSisHu}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 206
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoBroSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 207
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoBroDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 208
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoSisSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 209
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoSisDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 210
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaBroSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 211
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaBroDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 212
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaSisSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 213
%avo:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaSisDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 214
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaFaBroWi}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 215
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaFaSisHu}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 216
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoBroSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 217
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoBroDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 218
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoSisSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 219
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoSisDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 220
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaBroSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 221
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaBroDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 222
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaSisSoWi}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 223
%avo:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaSisDaHu}  
[ext], [ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 224
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoMoBroWi}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 225
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoMoSisHu}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 226
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoBroSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 227
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoBroDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 228
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoSisSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 229
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoMoSisDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 230
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaBroSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 231
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaBroDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 232
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaSisSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 233
%avo:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoMoFaSisDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 234
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoFaBroWi}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 235
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {MoFaSisHu}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 236
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoBroSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 237
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoBroDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 238
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoSisSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 239
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaMoSisDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 240
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaBroSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 241
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaBroDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 242
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaSisSoWi}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 243
%avo:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {MoFaFaSisDaHu}  
[ext], [ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 244
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaMoBroWi}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 245
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaMoSisHu}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 246
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoBroSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 247
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoBroDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 248
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoSisSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 249
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoMoSisDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 250
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaBroSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 251
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaBroDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 252
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaSisSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 253
%avo:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaMoFaSisDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 254
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaFaBroWi}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), spouse(Alter, E).
;; 255
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {FaFaSisHu}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), spouse(Alter, E).
;; 256
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoBroSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 257
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoBroDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 258
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoSisSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 259
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaMoSisDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 260
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaBroSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), spouse(Alter, G).
;; 261
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaBroDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), spouse(Alter, G).
;; 262
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaSisSoWi}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), spouse(Alter, G).
;; 263
%avo:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {FaFaFaSisDaHu}  
[ext], [ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), spouse(Alter, G).
;; 264
%avo:3, avo[aux]27:0, parents:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {HuMoMo}  
[ext],  spouse(A, Ego), male(A), mother(B, A), mother(Alter, B).
;; 265
%avo:3, avo[aux]27:0, parents:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {HuMoFa}  
[ext],  spouse(A, Ego), male(A), mother(B, A), father(Alter, B).
;; 266
%avo:3, avo[aux]27:0, parents:1, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {HuFaMo}  
[ext],  spouse(A, Ego), male(A), father(B, A), mother(Alter, B).
;; 267
%avo:3, avo[aux]27:0, parents:1, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {HuFaFa}  
[ext],  spouse(A, Ego), male(A), father(B, A), father(Alter, B).
;; 268
%avo:3, avo[aux]27:1, parents:0, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {WiMoMo}  
[ext],  spouse(A, Ego), female(A), mother(B, A), mother(Alter, B).
;; 269
%avo:3, avo[aux]27:1, parents:0, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {WiMoFa}  
[ext],  spouse(A, Ego), female(A), mother(B, A), father(Alter, B).
;; 270
%avo:3, avo[aux]27:1, parents:1, parents:0%
 Lvl=2,  PC=2, S=1, Star=0,  {WiFaMo}  
[ext],  spouse(A, Ego), female(A), father(B, A), mother(Alter, B).
;; 271
%avo:3, avo[aux]27:1, parents:1, parents:1%
 Lvl=2,  PC=2, S=1, Star=0,  {WiFaFa}  
[ext],  spouse(A, Ego), female(A), father(B, A), father(Alter, B).
;; 272
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoMoBro}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 273
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoMoSis}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 274
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 275
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 276
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 277
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoMoSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 278
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 279
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 280
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 281
%avo:3, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoMoFaSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 282
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoFaBro}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 283
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuMoFaSis}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 284
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 285
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 286
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 287
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaMoSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 288
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 289
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 290
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 291
%avo:3, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuMoFaFaSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 292
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaMoBro}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 293
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaMoSis}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 294
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 295
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 296
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 297
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoMoSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 298
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 299
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 300
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 301
%avo:3, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaMoFaSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 302
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaFaBro}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 303
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {HuFaFaSis}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 304
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 305
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 306
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 307
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaMoSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 308
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaBroSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 309
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaBroDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 310
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaSisSo}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 311
%avo:3, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {HuFaFaFaSisDa}  
[ext], [ext],  spouse(A, Ego), male(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 312
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoMoBro}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 313
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoMoSis}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 314
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 315
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 316
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 317
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoMoSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 318
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 319
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 320
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 321
%avo:3, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoMoFaSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 322
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoFaBro}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 323
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiMoFaSis}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 324
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 325
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 326
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 327
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaMoSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 328
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 329
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 330
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 331
%avo:3, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiMoFaFaSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 332
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaMoBro}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 333
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaMoSis}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 334
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 335
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 336
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 337
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoMoSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 338
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 339
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 340
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 341
%avo:3, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaMoFaSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 342
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaFaBro}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 343
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=2,  PC=6, S=1, Star=0,  {WiFaFaSis}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 344
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 345
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 346
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 347
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaMoSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).
;; 348
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaBroSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(Alter, G).
;; 349
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaBroDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(Alter, G).
;; 350
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaSisSo}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(Alter, G).
;; 351
%avo:3, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=2,  PC=8, S=1, Star=0,  {WiFaFaFaSisDa}  
[ext], [ext],  spouse(A, Ego), female(A), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(Alter, G).


avo[aux]27(Alter, Ego) :-  male(Ego), parents(A, Ego), parents(Alter, A).
                       |   female(Ego), parents(A, Ego), parents(Alter, A).
                       |  [ext],  male(Ego), parents(A, Ego), parents(B, A), generation[aux]27smallGS(Alter, B).
                       |  [ext],  female(Ego), parents(A, Ego), parents(B, A), generation[aux]27smallGS(Alter, B).
;; 0
%avo[aux]27:0, parents:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), mother(Alter, A).
;; 1
%avo[aux]27:0, parents:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), mother(A, Ego), father(Alter, A).
;; 2
%avo[aux]27:0, parents:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), father(A, Ego), mother(Alter, A).
;; 3
%avo[aux]27:0, parents:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 male(Ego), father(A, Ego), father(Alter, A).
;; 4
%avo[aux]27:1, parents:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), mother(Alter, A).
;; 5
%avo[aux]27:1, parents:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), mother(A, Ego), father(Alter, A).
;; 6
%avo[aux]27:1, parents:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), father(A, Ego), mother(Alter, A).
;; 7
%avo[aux]27:1, parents:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 female(Ego), father(A, Ego), father(Alter, A).
;; 8
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 9
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 10
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 11
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 12
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 13
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 14
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 15
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 16
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 17
%avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 18
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 19
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 20
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 21
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 22
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 23
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 24
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 25
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 26
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 27
%avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 28
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 29
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 30
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 31
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 32
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 33
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 34
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 35
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 36
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 37
%avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 38
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 39
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 40
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 41
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 42
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 43
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 44
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 45
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 46
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 47
%avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 48
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 49
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 50
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 51
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 52
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 53
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 54
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 55
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 56
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 57
%avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 58
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 59
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 60
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 61
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 62
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 63
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 64
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 65
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 66
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 67
%avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 68
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 69
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 70
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 71
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 72
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 73
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 74
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 75
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 76
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 77
%avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 78
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 79
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 80
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 81
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 82
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 83
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 84
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 85
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 86
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 87
%avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  female(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).


brother(Alter, Ego) :-  sibling(Alter, Ego), male(Alter).
;; 0
%brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).


children(Alter, Ego) :-  son(Alter, Ego).
                     |   daughter(Alter, Ego).
;; 0
%children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 son(Alter, Ego).
;; 1
%children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 daughter(Alter, Ego).


embisi(Alter, Ego) :-  embisi[aux]27(Alter, Ego).
                   |   embisi[aux]27(Ego, Alter).
{"BroDaHu_DaHu_FaBroDaDaHu_FaBroSoDaHu_FaSisDaDaHu_FaSisSoDaHu_HuBroDaHu_HuFaBroDaDaHu_HuFaBroSoDaHu_HuFaSisDaDaHu_HuFaSisSoDaHu_HuMoBroDaDaHu_HuMoBroSoDaHu_HuMoSisDaDaHu_HuMoSisSoDaHu_HuSisDaHu_MoBroDaDaHu_MoBroSoDaHu_MoSisDaDaHu_MoSisSoDaHu_SisDaHu_WiBroDaHu_WiFa_WiFaBro_WiFaBroDaDaHu_WiFaBroSoDaHu_WiFaBroWi_WiFaFaBroDa_WiFaFaBroDaHu_WiFaFaBroSo_WiFaFaBroSoWi_WiFaFaSisDa_WiFaFaSisDaHu_WiFaFaSisSo_WiFaFaSisSoWi_WiFaMoBroDa_WiFaMoBroDaHu_WiFaMoBroSo_WiFaMoBroSoWi_WiFaMoSisDa_WiFaMoSisDaHu_WiFaMoSisSo_WiFaMoSisSoWi_WiFaSis_WiFaSisDaDaHu_WiFaSisHu_WiFaSisSoDaHu_WiMo_WiMoBro_WiMoBroDaDaHu_WiMoBroSoDaHu_WiMoBroWi_WiMoFaBroDa_WiMoFaBroDaHu_WiMoFaBroSo_WiMoFaBroSoWi_WiMoFaSisDa_WiMoFaSisDaHu_WiMoFaSisSo_WiMoFaSisSoWi_WiMoMoBroDa_WiMoMoBroDaHu_WiMoMoBroSo_WiMoMoBroSoWi_WiMoMoSisDa_WiMoMoSisDaHu_WiMoMoSisSo_WiMoMoSisSoWi_WiMoSis_WiMoSisDaDaHu_WiMoSisHu_WiMoSisSoDaHu_WiSisDaHu"}
;; 0
%embisi:0, embisi[aux]27:0, parents:0%
 Lvl=1,  PC=1, S=1, Star=0,  {WiMo}  
 wife(A, Ego), mother(Alter, A).
;; 1
%embisi:0, embisi[aux]27:0, parents:1%
 Lvl=1,  PC=1, S=1, Star=0,  {WiFa}  
 wife(A, Ego), father(Alter, A).
;; 2
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiMoBro}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 3
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiMoSis}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 4
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoBroSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 5
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoBroDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 6
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoSisSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 7
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoMoSisDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 8
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaBroSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 9
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaBroDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 10
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaSisSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 11
%embisi:0, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiMoFaSisDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 12
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiFaBro}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 13
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {WiFaSis}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 14
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoBroSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 15
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoBroDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 16
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoSisSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 17
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaMoSisDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 18
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaBroSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 19
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaBroDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 20
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaSisSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 21
%embisi:0, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {WiFaFaSisDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 22
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=1,  PC=5, S=2, Star=0,  {WiMoSisHu}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 23
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=1,  PC=5, S=2, Star=0,  {WiMoBroWi}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 24
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoMoBroDaHu}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 25
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoMoBroSoWi}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 26
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoMoSisDaHu}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 27
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoMoSisSoWi}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 28
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoFaBroDaHu}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 29
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoFaBroSoWi}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 30
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoFaSisDaHu}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 31
%embisi:0, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiMoFaSisSoWi}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 32
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=1,  PC=5, S=2, Star=0,  {WiFaSisHu}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 33
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=1,  PC=5, S=2, Star=0,  {WiFaBroWi}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 34
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaMoBroDaHu}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 35
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaMoBroSoWi}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 36
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaMoSisDaHu}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 37
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaMoSisSoWi}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 38
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaFaBroDaHu}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 39
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaFaBroSoWi}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 40
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaFaSisDaHu}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 41
%embisi:0, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {WiFaFaSisSoWi}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 42
%embisi:1, embisi[aux]27:0, parents:0%
 Lvl=-1,  PC=1, S=1, Star=0,  {DaHu}  
 wife(A, Alter), mother(Ego, A).
;; 43
%embisi:1, embisi[aux]27:0, parents:1%
 Lvl=-1,  PC=1, S=1, Star=0,  {DaHu}  
 wife(A, Alter), father(Ego, A).
;; 44
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 45
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 46
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 47
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 48
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 49
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 50
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 51
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 52
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 53
%embisi:1, embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 54
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 55
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 56
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 57
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 58
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 59
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 60
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 61
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 62
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 63
%embisi:1, embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 64
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=-1,  PC=5, S=2, Star=0,  {WiSisDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Ego, E).
;; 65
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=-1,  PC=5, S=2, Star=0,  {HuSisDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Ego, E).
;; 66
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 67
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 68
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 69
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoSisDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).
;; 70
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 71
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 72
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 73
%embisi:1, embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoBroDaDaHu}  
[ext],  wife(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).
;; 74
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=-1,  PC=5, S=2, Star=0,  {WiBroDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Ego, E).
;; 75
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=-1,  PC=5, S=2, Star=0,  {HuBroDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Ego, E).
;; 76
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 77
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 78
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 79
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoSisSoDaHu}  
[ext],  wife(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).
;; 80
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 81
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 82
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 83
%embisi:1, embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoBroSoDaHu}  
[ext],  wife(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).


embisi[aux]27(Alter, Ego) :-  wife(A, Ego), parents(Alter, A).
                          |  [ext],  wife(A, Ego), parents(B, A), generation[aux]27smallGS(Alter, B).
                          |  [ext],  wife(A, Ego), parents(B, A), generation[aux]27small(C, B), spice(Alter, C).
;; 0
%embisi[aux]27:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), mother(Alter, A).
;; 1
%embisi[aux]27:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(A, Ego), father(Alter, A).
;; 2
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 3
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 4
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 5
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 6
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 7
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 8
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 9
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 10
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 11
%embisi[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 12
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 13
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 14
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 15
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 16
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 17
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 18
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 19
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 20
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 21
%embisi[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 22
%embisi[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 23
%embisi[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 24
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 25
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 26
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 27
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 28
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 29
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 30
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 31
%embisi[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 32
%embisi[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 33
%embisi[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 34
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 35
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 36
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 37
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 38
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 39
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 40
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 41
%embisi[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).


erway(Alter, Ego) :-  parent(A, Ego), avo[aux]27(Alter, A).
                  |   children(A, Ego), children(B, A), children(Alter, B).
                  |  [ext],  parent(A, Ego), avo[aux]27(B, A), spouse(Alter, B).
                  |  [ext],  spice(A, Ego), parent(B, A), avo[aux]27(Alter, B).
                  |  [ext],  spice(A, Ego), parent(B, A), avo[aux]27(C, B), spouse(Alter, C).
                  |  [ext],  children(A, Ego), children(B, A), children(C, B), spouse(Alter, C).
{"DaDaDa_DaDaDaHu_DaDaSo_DaDaSoWi_DaSoDa_DaSoDaHu_DaSoSo_DaSoSoWi_FaFaFa_FaFaFaBro_FaFaFaBroWi_FaFaFaSis_FaFaFaSisHu_FaFaMo_FaFaMoBro_FaFaMoBroWi_FaFaMoSis_FaFaMoSisHu_FaMoFa_FaMoFaBro_FaMoFaBroWi_FaMoFaSis_FaMoFaSisHu_FaMoMo_FaMoMoBro_FaMoMoBroWi_FaMoMoSis_FaMoMoSisHu_HuFaFaFa_HuFaFaFaBro_HuFaFaFaBroWi_HuFaFaFaSis_HuFaFaFaSisHu_HuFaFaMo_HuFaFaMoBro_HuFaFaMoBroWi_HuFaFaMoSis_HuFaFaMoSisHu_HuFaMoFa_HuFaMoFaBro_HuFaMoFaBroWi_HuFaMoFaSis_HuFaMoFaSisHu_HuFaMoMo_HuFaMoMoBro_HuFaMoMoBroWi_HuFaMoMoSis_HuFaMoMoSisHu_HuMoFaFa_HuMoFaFaBro_HuMoFaFaBroWi_HuMoFaFaSis_HuMoFaFaSisHu_HuMoFaMo_HuMoFaMoBro_HuMoFaMoBroWi_HuMoFaMoSis_HuMoFaMoSisHu_HuMoMoFa_HuMoMoFaBro_HuMoMoFaBroWi_HuMoMoFaSis_HuMoMoFaSisHu_HuMoMoMo_HuMoMoMoBro_HuMoMoMoBroWi_HuMoMoMoSis_HuMoMoMoSisHu_MoFaFa_MoFaFaBro_MoFaFaBroWi_MoFaFaSis_MoFaFaSisHu_MoFaMo_MoFaMoBro_MoFaMoBroWi_MoFaMoSis_MoFaMoSisHu_MoMoFa_MoMoFaBro_MoMoFaBroWi_MoMoFaSis_MoMoFaSisHu_MoMoMo_MoMoMoBro_MoMoMoBroWi_MoMoMoSis_MoMoMoSisHu_SoDaDa_SoDaDaHu_SoDaSo_SoDaSoWi_SoSoDa_SoSoDaHu_SoSoSo_SoSoSoWi_WiFaFaFa_WiFaFaFaBro_WiFaFaFaBroWi_WiFaFaFaSis_WiFaFaFaSisHu_WiFaFaMo_WiFaFaMoBro_WiFaFaMoBroWi_WiFaFaMoSis_WiFaFaMoSisHu_WiFaMoFa_WiFaMoFaBro_WiFaMoFaBroWi_WiFaMoFaSis_WiFaMoFaSisHu_WiFaMoMo_WiFaMoMoBro_WiFaMoMoBroWi_WiFaMoMoSis_WiFaMoMoSisHu_WiMoFaFa_WiMoFaFaBro_WiMoFaFaBroWi_WiMoFaFaSis_WiMoFaFaSisHu_WiMoFaMo_WiMoFaMoBro_WiMoFaMoBroWi_WiMoFaMoSis_WiMoFaMoSisHu_WiMoMoFa_WiMoMoFaBro_WiMoMoFaBroWi_WiMoMoFaSis_WiMoMoFaSisHu_WiMoMoMo_WiMoMoMoBro_WiMoMoMoBroWi_WiMoMoMoSis_WiMoMoMoSisHu"}
;; 0
%erway:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {FaMoMo}  
 parent(A, Ego), male(A), mother(B, A), mother(Alter, B).
;; 1
%erway:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {FaMoFa}  
 parent(A, Ego), male(A), mother(B, A), father(Alter, B).
;; 2
%erway:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {FaFaMo}  
 parent(A, Ego), male(A), father(B, A), mother(Alter, B).
;; 3
%erway:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {FaFaFa}  
 parent(A, Ego), male(A), father(B, A), father(Alter, B).
;; 4
%erway:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {MoMoMo}  
 parent(A, Ego), female(A), mother(B, A), mother(Alter, B).
;; 5
%erway:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {MoMoFa}  
 parent(A, Ego), female(A), mother(B, A), father(Alter, B).
;; 6
%erway:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=3,  PC=3, S=0, Star=0,  {MoFaMo}  
 parent(A, Ego), female(A), father(B, A), mother(Alter, B).
;; 7
%erway:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=3,  PC=3, S=0, Star=0,  {MoFaFa}  
 parent(A, Ego), female(A), father(B, A), father(Alter, B).
;; 8
%erway:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoMoBro}  
[ext],  parent(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 9
%erway:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoMoSis}  
[ext],  parent(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 10
%erway:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoFaBro}  
[ext],  parent(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 11
%erway:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaMoFaSis}  
[ext],  parent(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 12
%erway:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaMoBro}  
[ext],  parent(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 13
%erway:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaMoSis}  
[ext],  parent(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 14
%erway:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaFaBro}  
[ext],  parent(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 15
%erway:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {FaFaFaSis}  
[ext],  parent(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 16
%erway:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoMoBro}  
[ext],  parent(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 17
%erway:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoMoSis}  
[ext],  parent(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 18
%erway:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoFaBro}  
[ext],  parent(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 19
%erway:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoMoFaSis}  
[ext],  parent(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 20
%erway:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaMoBro}  
[ext],  parent(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 21
%erway:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaMoSis}  
[ext],  parent(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 22
%erway:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaFaBro}  
[ext],  parent(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), male(Alter).
;; 23
%erway:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=0, Star=0,  {MoFaFaSis}  
[ext],  parent(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(Alter, D), child(Alter, E), not(equal(Alter, C)), female(Alter).
;; 24
%erway:1, children:0, children:0, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoSoSo}  
 son(A, Ego), son(B, A), son(Alter, B).
;; 25
%erway:1, children:0, children:0, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoSoDa}  
 son(A, Ego), son(B, A), daughter(Alter, B).
;; 26
%erway:1, children:0, children:1, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoDaSo}  
 son(A, Ego), daughter(B, A), son(Alter, B).
;; 27
%erway:1, children:0, children:1, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {SoDaDa}  
 son(A, Ego), daughter(B, A), daughter(Alter, B).
;; 28
%erway:1, children:1, children:0, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaSoSo}  
 daughter(A, Ego), son(B, A), son(Alter, B).
;; 29
%erway:1, children:1, children:0, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaSoDa}  
 daughter(A, Ego), son(B, A), daughter(Alter, B).
;; 30
%erway:1, children:1, children:1, children:0%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaDaSo}  
 daughter(A, Ego), daughter(B, A), son(Alter, B).
;; 31
%erway:1, children:1, children:1, children:1%
 Lvl=-3,  PC=3, S=0, Star=0,  {DaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(Alter, B).
;; 32
%erway:2, avo[aux]27:0, parents:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {FaMoFa}  
[ext],  parent(A, Ego), male(A), mother(B, A), mother(C, B), spouse(Alter, C).
;; 33
%erway:2, avo[aux]27:0, parents:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {FaMoMo}  
[ext],  parent(A, Ego), male(A), mother(B, A), father(C, B), spouse(Alter, C).
;; 34
%erway:2, avo[aux]27:0, parents:1, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {FaFaFa}  
[ext],  parent(A, Ego), male(A), father(B, A), mother(C, B), spouse(Alter, C).
;; 35
%erway:2, avo[aux]27:0, parents:1, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {FaFaMo}  
[ext],  parent(A, Ego), male(A), father(B, A), father(C, B), spouse(Alter, C).
;; 36
%erway:2, avo[aux]27:1, parents:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {MoMoFa}  
[ext],  parent(A, Ego), female(A), mother(B, A), mother(C, B), spouse(Alter, C).
;; 37
%erway:2, avo[aux]27:1, parents:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {MoMoMo}  
[ext],  parent(A, Ego), female(A), mother(B, A), father(C, B), spouse(Alter, C).
;; 38
%erway:2, avo[aux]27:1, parents:1, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {MoFaFa}  
[ext],  parent(A, Ego), female(A), father(B, A), mother(C, B), spouse(Alter, C).
;; 39
%erway:2, avo[aux]27:1, parents:1, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {MoFaMo}  
[ext],  parent(A, Ego), female(A), father(B, A), father(C, B), spouse(Alter, C).
;; 40
%erway:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoMoBroWi}  
[ext], [ext],  parent(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 41
%erway:2, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoMoSisHu}  
[ext], [ext],  parent(A, Ego), male(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 42
%erway:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoFaBroWi}  
[ext], [ext],  parent(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 43
%erway:2, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaMoFaSisHu}  
[ext], [ext],  parent(A, Ego), male(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 44
%erway:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaMoBroWi}  
[ext], [ext],  parent(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 45
%erway:2, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaMoSisHu}  
[ext], [ext],  parent(A, Ego), male(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 46
%erway:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaFaBroWi}  
[ext], [ext],  parent(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 47
%erway:2, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {FaFaFaSisHu}  
[ext], [ext],  parent(A, Ego), male(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 48
%erway:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoMoBroWi}  
[ext], [ext],  parent(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 49
%erway:2, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoMoSisHu}  
[ext], [ext],  parent(A, Ego), female(A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 50
%erway:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoFaBroWi}  
[ext], [ext],  parent(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 51
%erway:2, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoMoFaSisHu}  
[ext], [ext],  parent(A, Ego), female(A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 52
%erway:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaMoBroWi}  
[ext], [ext],  parent(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 53
%erway:2, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaMoSisHu}  
[ext], [ext],  parent(A, Ego), female(A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 54
%erway:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaFaBroWi}  
[ext], [ext],  parent(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), spouse(Alter, F).
;; 55
%erway:2, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {MoFaFaSisHu}  
[ext], [ext],  parent(A, Ego), female(A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), spouse(Alter, F).
;; 56
%erway:3, spice:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {HuFaMoMo}  
[ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), mother(Alter, C).
;; 57
%erway:3, spice:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {HuFaMoFa}  
[ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), father(Alter, C).
;; 58
%erway:3, spice:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {HuFaFaMo}  
[ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), mother(Alter, C).
;; 59
%erway:3, spice:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {HuFaFaFa}  
[ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), father(Alter, C).
;; 60
%erway:3, spice:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {HuMoMoMo}  
[ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), mother(Alter, C).
;; 61
%erway:3, spice:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {HuMoMoFa}  
[ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), father(Alter, C).
;; 62
%erway:3, spice:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {HuMoFaMo}  
[ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), mother(Alter, C).
;; 63
%erway:3, spice:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {HuMoFaFa}  
[ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), father(Alter, C).
;; 64
%erway:3, spice:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaMoMoBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 65
%erway:3, spice:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaMoMoSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 66
%erway:3, spice:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaMoFaBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 67
%erway:3, spice:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaMoFaSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 68
%erway:3, spice:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaFaMoBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 69
%erway:3, spice:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaFaMoSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 70
%erway:3, spice:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaFaFaBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 71
%erway:3, spice:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuFaFaFaSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 72
%erway:3, spice:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoMoMoBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 73
%erway:3, spice:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoMoMoSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 74
%erway:3, spice:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoMoFaBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 75
%erway:3, spice:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoMoFaSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 76
%erway:3, spice:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoFaMoBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 77
%erway:3, spice:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoFaMoSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 78
%erway:3, spice:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoFaFaBro}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 79
%erway:3, spice:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {HuMoFaFaSis}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 80
%erway:3, spice:1, avo[aux]27:0, parents:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {WiFaMoMo}  
[ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), mother(Alter, C).
;; 81
%erway:3, spice:1, avo[aux]27:0, parents:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {WiFaMoFa}  
[ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), father(Alter, C).
;; 82
%erway:3, spice:1, avo[aux]27:0, parents:1, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {WiFaFaMo}  
[ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), mother(Alter, C).
;; 83
%erway:3, spice:1, avo[aux]27:0, parents:1, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {WiFaFaFa}  
[ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), father(Alter, C).
;; 84
%erway:3, spice:1, avo[aux]27:1, parents:0, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {WiMoMoMo}  
[ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), mother(Alter, C).
;; 85
%erway:3, spice:1, avo[aux]27:1, parents:0, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {WiMoMoFa}  
[ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), father(Alter, C).
;; 86
%erway:3, spice:1, avo[aux]27:1, parents:1, parents:0%
 Lvl=3,  PC=3, S=1, Star=0,  {WiMoFaMo}  
[ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), mother(Alter, C).
;; 87
%erway:3, spice:1, avo[aux]27:1, parents:1, parents:1%
 Lvl=3,  PC=3, S=1, Star=0,  {WiMoFaFa}  
[ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), father(Alter, C).
;; 88
%erway:3, spice:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaMoMoBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 89
%erway:3, spice:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaMoMoSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 90
%erway:3, spice:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaMoFaBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 91
%erway:3, spice:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaMoFaSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 92
%erway:3, spice:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaFaMoBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 93
%erway:3, spice:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaFaMoSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 94
%erway:3, spice:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaFaFaBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 95
%erway:3, spice:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiFaFaFaSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 96
%erway:3, spice:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoMoMoBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 97
%erway:3, spice:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoMoMoSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 98
%erway:3, spice:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoMoFaBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 99
%erway:3, spice:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoMoFaSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 100
%erway:3, spice:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoFaMoBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 101
%erway:3, spice:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoFaMoSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 102
%erway:3, spice:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoFaFaBro}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), male(Alter).
;; 103
%erway:3, spice:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=1, Star=0,  {WiMoFaFaSis}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(Alter, E), child(Alter, F), not(equal(Alter, D)), female(Alter).
;; 104
%erway:4, spice:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {HuFaMoFa}  
[ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), spouse(Alter, D).
;; 105
%erway:4, spice:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {HuFaMoMo}  
[ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), spouse(Alter, D).
;; 106
%erway:4, spice:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {HuFaFaFa}  
[ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), spouse(Alter, D).
;; 107
%erway:4, spice:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {HuFaFaMo}  
[ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), spouse(Alter, D).
;; 108
%erway:4, spice:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {HuMoMoFa}  
[ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), spouse(Alter, D).
;; 109
%erway:4, spice:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {HuMoMoMo}  
[ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), spouse(Alter, D).
;; 110
%erway:4, spice:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {HuMoFaFa}  
[ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), spouse(Alter, D).
;; 111
%erway:4, spice:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {HuMoFaMo}  
[ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), spouse(Alter, D).
;; 112
%erway:4, spice:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaMoMoBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 113
%erway:4, spice:0, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaMoMoSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 114
%erway:4, spice:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaMoFaBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 115
%erway:4, spice:0, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaMoFaSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 116
%erway:4, spice:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaFaMoBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 117
%erway:4, spice:0, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaFaMoSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 118
%erway:4, spice:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaFaFaBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 119
%erway:4, spice:0, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuFaFaFaSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 120
%erway:4, spice:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoMoMoBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 121
%erway:4, spice:0, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoMoMoSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 122
%erway:4, spice:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoMoFaBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 123
%erway:4, spice:0, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoMoFaSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 124
%erway:4, spice:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoFaMoBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 125
%erway:4, spice:0, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoFaMoSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 126
%erway:4, spice:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoFaFaBroWi}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 127
%erway:4, spice:0, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {HuMoFaFaSisHu}  
[ext], [ext],  husband(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 128
%erway:4, spice:1, avo[aux]27:0, parents:0, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {WiFaMoFa}  
[ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), spouse(Alter, D).
;; 129
%erway:4, spice:1, avo[aux]27:0, parents:0, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {WiFaMoMo}  
[ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), spouse(Alter, D).
;; 130
%erway:4, spice:1, avo[aux]27:0, parents:1, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {WiFaFaFa}  
[ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), spouse(Alter, D).
;; 131
%erway:4, spice:1, avo[aux]27:0, parents:1, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {WiFaFaMo}  
[ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), spouse(Alter, D).
;; 132
%erway:4, spice:1, avo[aux]27:1, parents:0, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {WiMoMoFa}  
[ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), spouse(Alter, D).
;; 133
%erway:4, spice:1, avo[aux]27:1, parents:0, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {WiMoMoMo}  
[ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), spouse(Alter, D).
;; 134
%erway:4, spice:1, avo[aux]27:1, parents:1, parents:0%
 Lvl=3,  PC=3, S=2, Star=0,  {WiMoFaFa}  
[ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), spouse(Alter, D).
;; 135
%erway:4, spice:1, avo[aux]27:1, parents:1, parents:1%
 Lvl=3,  PC=3, S=2, Star=0,  {WiMoFaMo}  
[ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), spouse(Alter, D).
;; 136
%erway:4, spice:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaMoMoBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 137
%erway:4, spice:1, avo[aux]27:2, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaMoMoSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 138
%erway:4, spice:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaMoFaBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 139
%erway:4, spice:1, avo[aux]27:2, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaMoFaSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 140
%erway:4, spice:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaFaMoBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 141
%erway:4, spice:1, avo[aux]27:2, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaFaMoSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 142
%erway:4, spice:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaFaFaBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 143
%erway:4, spice:1, avo[aux]27:2, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiFaFaFaSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), male(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 144
%erway:4, spice:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoMoMoBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 145
%erway:4, spice:1, avo[aux]27:3, parents:0, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoMoMoSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 146
%erway:4, spice:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoMoFaBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 147
%erway:4, spice:1, avo[aux]27:3, parents:0, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoMoFaSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 148
%erway:4, spice:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoFaMoBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 149
%erway:4, spice:1, avo[aux]27:3, parents:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoFaMoSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 150
%erway:4, spice:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoFaFaBroWi}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), spouse(Alter, G).
;; 151
%erway:4, spice:1, avo[aux]27:3, parents:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=3,  PC=7, S=2, Star=0,  {WiMoFaFaSisHu}  
[ext], [ext],  wife(A, Ego), parent(B, A), female(B), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), spouse(Alter, G).
;; 152
%erway:5, children:0, children:0, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoSoSoWi}  
[ext],  son(A, Ego), son(B, A), son(C, B), spouse(Alter, C).
;; 153
%erway:5, children:0, children:0, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoSoDaHu}  
[ext],  son(A, Ego), son(B, A), daughter(C, B), spouse(Alter, C).
;; 154
%erway:5, children:0, children:1, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoDaSoWi}  
[ext],  son(A, Ego), daughter(B, A), son(C, B), spouse(Alter, C).
;; 155
%erway:5, children:0, children:1, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {SoDaDaHu}  
[ext],  son(A, Ego), daughter(B, A), daughter(C, B), spouse(Alter, C).
;; 156
%erway:5, children:1, children:0, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaSoSoWi}  
[ext],  daughter(A, Ego), son(B, A), son(C, B), spouse(Alter, C).
;; 157
%erway:5, children:1, children:0, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaSoDaHu}  
[ext],  daughter(A, Ego), son(B, A), daughter(C, B), spouse(Alter, C).
;; 158
%erway:5, children:1, children:1, children:0%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaDaSoWi}  
[ext],  daughter(A, Ego), daughter(B, A), son(C, B), spouse(Alter, C).
;; 159
%erway:5, children:1, children:1, children:1%
 Lvl=-3,  PC=3, S=1, Star=0,  {DaDaDaHu}  
[ext],  daughter(A, Ego), daughter(B, A), daughter(C, B), spouse(Alter, C).


fasuu(Alter, Ego) :-  parents(A, Ego), parent(B, A), avo[aux]27(Alter, B).
                  |   children(A, Ego), children(B, A), children(C, B), children(Alter, C).
                  |  [ext],  spice(A, Ego), parents(B, A), parent(C, B), avo[aux]27(Alter, C).
                  |  [ext],  children(A, Ego), children(B, A), children(C, B), children(D, C), spouse(Alter, D).
{"DaDaDaDa_DaDaDaDaHu_DaDaDaSo_DaDaDaSoWi_DaDaSoDa_DaDaSoDaHu_DaDaSoSo_DaDaSoSoWi_DaSoDaDa_DaSoDaDaHu_DaSoDaSo_DaSoDaSoWi_DaSoSoDa_DaSoSoDaHu_DaSoSoSo_DaSoSoSoWi_FaFaFaFa_FaFaFaMo_FaFaMoFa_FaFaMoMo_FaMoFaFa_FaMoFaMo_FaMoMoFa_FaMoMoMo_HuFaFaFaFa_HuFaFaFaMo_HuFaFaMoFa_HuFaFaMoMo_HuFaMoFaFa_HuFaMoFaMo_HuFaMoMoFa_HuFaMoMoMo_HuMoFaFaFa_HuMoFaFaMo_HuMoFaMoFa_HuMoFaMoMo_HuMoMoFaFa_HuMoMoFaMo_HuMoMoMoFa_HuMoMoMoMo_MoFaFaFa_MoFaFaMo_MoFaMoFa_MoFaMoMo_MoMoFaFa_MoMoFaMo_MoMoMoFa_MoMoMoMo_SoDaDaDa_SoDaDaDaHu_SoDaDaSo_SoDaDaSoWi_SoDaSoDa_SoDaSoDaHu_SoDaSoSo_SoDaSoSoWi_SoSoDaDa_SoSoDaDaHu_SoSoDaSo_SoSoDaSoWi_SoSoSoDa_SoSoSoDaHu_SoSoSoSo_SoSoSoSoWi_WiFaFaFaFa_WiFaFaFaMo_WiFaFaMoFa_WiFaFaMoMo_WiFaMoFaFa_WiFaMoFaMo_WiFaMoMoFa_WiFaMoMoMo_WiMoFaFaFa_WiMoFaFaMo_WiMoFaMoFa_WiMoFaMoMo_WiMoMoFaFa_WiMoMoFaMo_WiMoMoMoFa_WiMoMoMoMo"}
;; 0
%fasuu:0, parents:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {MoFaMoMo}  
 mother(A, Ego), parent(B, A), male(B), mother(C, B), mother(Alter, C).
;; 1
%fasuu:0, parents:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {MoFaMoFa}  
 mother(A, Ego), parent(B, A), male(B), mother(C, B), father(Alter, C).
;; 2
%fasuu:0, parents:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {MoFaFaMo}  
 mother(A, Ego), parent(B, A), male(B), father(C, B), mother(Alter, C).
;; 3
%fasuu:0, parents:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {MoFaFaFa}  
 mother(A, Ego), parent(B, A), male(B), father(C, B), father(Alter, C).
;; 4
%fasuu:0, parents:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {MoMoMoMo}  
 mother(A, Ego), parent(B, A), female(B), mother(C, B), mother(Alter, C).
;; 5
%fasuu:0, parents:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {MoMoMoFa}  
 mother(A, Ego), parent(B, A), female(B), mother(C, B), father(Alter, C).
;; 6
%fasuu:0, parents:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {MoMoFaMo}  
 mother(A, Ego), parent(B, A), female(B), father(C, B), mother(Alter, C).
;; 7
%fasuu:0, parents:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {MoMoFaFa}  
 mother(A, Ego), parent(B, A), female(B), father(C, B), father(Alter, C).
;; 8
%fasuu:0, parents:1, avo[aux]27:0, parents:0, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {FaFaMoMo}  
 father(A, Ego), parent(B, A), male(B), mother(C, B), mother(Alter, C).
;; 9
%fasuu:0, parents:1, avo[aux]27:0, parents:0, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {FaFaMoFa}  
 father(A, Ego), parent(B, A), male(B), mother(C, B), father(Alter, C).
;; 10
%fasuu:0, parents:1, avo[aux]27:0, parents:1, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {FaFaFaMo}  
 father(A, Ego), parent(B, A), male(B), father(C, B), mother(Alter, C).
;; 11
%fasuu:0, parents:1, avo[aux]27:0, parents:1, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {FaFaFaFa}  
 father(A, Ego), parent(B, A), male(B), father(C, B), father(Alter, C).
;; 12
%fasuu:0, parents:1, avo[aux]27:1, parents:0, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {FaMoMoMo}  
 father(A, Ego), parent(B, A), female(B), mother(C, B), mother(Alter, C).
;; 13
%fasuu:0, parents:1, avo[aux]27:1, parents:0, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {FaMoMoFa}  
 father(A, Ego), parent(B, A), female(B), mother(C, B), father(Alter, C).
;; 14
%fasuu:0, parents:1, avo[aux]27:1, parents:1, parents:0%
 Lvl=4,  PC=4, S=0, Star=0,  {FaMoFaMo}  
 father(A, Ego), parent(B, A), female(B), father(C, B), mother(Alter, C).
;; 15
%fasuu:0, parents:1, avo[aux]27:1, parents:1, parents:1%
 Lvl=4,  PC=4, S=0, Star=0,  {FaMoFaFa}  
 father(A, Ego), parent(B, A), female(B), father(C, B), father(Alter, C).
;; 16
%fasuu:1, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoSoSo}  
 son(A, Ego), son(B, A), son(C, B), son(Alter, C).
;; 17
%fasuu:1, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoSoDa}  
 son(A, Ego), son(B, A), son(C, B), daughter(Alter, C).
;; 18
%fasuu:1, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoDaSo}  
 son(A, Ego), son(B, A), daughter(C, B), son(Alter, C).
;; 19
%fasuu:1, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoSoDaDa}  
 son(A, Ego), son(B, A), daughter(C, B), daughter(Alter, C).
;; 20
%fasuu:1, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaSoSo}  
 son(A, Ego), daughter(B, A), son(C, B), son(Alter, C).
;; 21
%fasuu:1, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaSoDa}  
 son(A, Ego), daughter(B, A), son(C, B), daughter(Alter, C).
;; 22
%fasuu:1, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaDaSo}  
 son(A, Ego), daughter(B, A), daughter(C, B), son(Alter, C).
;; 23
%fasuu:1, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {SoDaDaDa}  
 son(A, Ego), daughter(B, A), daughter(C, B), daughter(Alter, C).
;; 24
%fasuu:1, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoSoSo}  
 daughter(A, Ego), son(B, A), son(C, B), son(Alter, C).
;; 25
%fasuu:1, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoSoDa}  
 daughter(A, Ego), son(B, A), son(C, B), daughter(Alter, C).
;; 26
%fasuu:1, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoDaSo}  
 daughter(A, Ego), son(B, A), daughter(C, B), son(Alter, C).
;; 27
%fasuu:1, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaSoDaDa}  
 daughter(A, Ego), son(B, A), daughter(C, B), daughter(Alter, C).
;; 28
%fasuu:1, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaSoSo}  
 daughter(A, Ego), daughter(B, A), son(C, B), son(Alter, C).
;; 29
%fasuu:1, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaSoDa}  
 daughter(A, Ego), daughter(B, A), son(C, B), daughter(Alter, C).
;; 30
%fasuu:1, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaDaSo}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), son(Alter, C).
;; 31
%fasuu:1, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=0, Star=0,  {DaDaDaDa}  
 daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(Alter, C).
;; 32
%fasuu:2, spice:0, parents:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoFaMoMo}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), male(C), mother(D, C), mother(Alter, D).
;; 33
%fasuu:2, spice:0, parents:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoFaMoFa}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), male(C), mother(D, C), father(Alter, D).
;; 34
%fasuu:2, spice:0, parents:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoFaFaMo}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), male(C), father(D, C), mother(Alter, D).
;; 35
%fasuu:2, spice:0, parents:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoFaFaFa}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), male(C), father(D, C), father(Alter, D).
;; 36
%fasuu:2, spice:0, parents:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoMoMoMo}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), female(C), mother(D, C), mother(Alter, D).
;; 37
%fasuu:2, spice:0, parents:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoMoMoFa}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), female(C), mother(D, C), father(Alter, D).
;; 38
%fasuu:2, spice:0, parents:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoMoFaMo}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), female(C), father(D, C), mother(Alter, D).
;; 39
%fasuu:2, spice:0, parents:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuMoMoFaFa}  
[ext],  husband(A, Ego), mother(B, A), parent(C, B), female(C), father(D, C), father(Alter, D).
;; 40
%fasuu:2, spice:0, parents:1, avo[aux]27:0, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaFaMoMo}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), male(C), mother(D, C), mother(Alter, D).
;; 41
%fasuu:2, spice:0, parents:1, avo[aux]27:0, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaFaMoFa}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), male(C), mother(D, C), father(Alter, D).
;; 42
%fasuu:2, spice:0, parents:1, avo[aux]27:0, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaFaFaMo}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), male(C), father(D, C), mother(Alter, D).
;; 43
%fasuu:2, spice:0, parents:1, avo[aux]27:0, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaFaFaFa}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), male(C), father(D, C), father(Alter, D).
;; 44
%fasuu:2, spice:0, parents:1, avo[aux]27:1, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaMoMoMo}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), female(C), mother(D, C), mother(Alter, D).
;; 45
%fasuu:2, spice:0, parents:1, avo[aux]27:1, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaMoMoFa}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), female(C), mother(D, C), father(Alter, D).
;; 46
%fasuu:2, spice:0, parents:1, avo[aux]27:1, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaMoFaMo}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), female(C), father(D, C), mother(Alter, D).
;; 47
%fasuu:2, spice:0, parents:1, avo[aux]27:1, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {HuFaMoFaFa}  
[ext],  husband(A, Ego), father(B, A), parent(C, B), female(C), father(D, C), father(Alter, D).
;; 48
%fasuu:2, spice:1, parents:0, avo[aux]27:0, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoFaMoMo}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), male(C), mother(D, C), mother(Alter, D).
;; 49
%fasuu:2, spice:1, parents:0, avo[aux]27:0, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoFaMoFa}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), male(C), mother(D, C), father(Alter, D).
;; 50
%fasuu:2, spice:1, parents:0, avo[aux]27:0, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoFaFaMo}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), male(C), father(D, C), mother(Alter, D).
;; 51
%fasuu:2, spice:1, parents:0, avo[aux]27:0, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoFaFaFa}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), male(C), father(D, C), father(Alter, D).
;; 52
%fasuu:2, spice:1, parents:0, avo[aux]27:1, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoMoMoMo}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), female(C), mother(D, C), mother(Alter, D).
;; 53
%fasuu:2, spice:1, parents:0, avo[aux]27:1, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoMoMoFa}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), female(C), mother(D, C), father(Alter, D).
;; 54
%fasuu:2, spice:1, parents:0, avo[aux]27:1, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoMoFaMo}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), female(C), father(D, C), mother(Alter, D).
;; 55
%fasuu:2, spice:1, parents:0, avo[aux]27:1, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiMoMoFaFa}  
[ext],  wife(A, Ego), mother(B, A), parent(C, B), female(C), father(D, C), father(Alter, D).
;; 56
%fasuu:2, spice:1, parents:1, avo[aux]27:0, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaFaMoMo}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), male(C), mother(D, C), mother(Alter, D).
;; 57
%fasuu:2, spice:1, parents:1, avo[aux]27:0, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaFaMoFa}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), male(C), mother(D, C), father(Alter, D).
;; 58
%fasuu:2, spice:1, parents:1, avo[aux]27:0, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaFaFaMo}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), male(C), father(D, C), mother(Alter, D).
;; 59
%fasuu:2, spice:1, parents:1, avo[aux]27:0, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaFaFaFa}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), male(C), father(D, C), father(Alter, D).
;; 60
%fasuu:2, spice:1, parents:1, avo[aux]27:1, parents:0, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaMoMoMo}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), female(C), mother(D, C), mother(Alter, D).
;; 61
%fasuu:2, spice:1, parents:1, avo[aux]27:1, parents:0, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaMoMoFa}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), female(C), mother(D, C), father(Alter, D).
;; 62
%fasuu:2, spice:1, parents:1, avo[aux]27:1, parents:1, parents:0%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaMoFaMo}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), female(C), father(D, C), mother(Alter, D).
;; 63
%fasuu:2, spice:1, parents:1, avo[aux]27:1, parents:1, parents:1%
 Lvl=4,  PC=4, S=1, Star=0,  {WiFaMoFaFa}  
[ext],  wife(A, Ego), father(B, A), parent(C, B), female(C), father(D, C), father(Alter, D).
;; 64
%fasuu:3, children:0, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoSoSoWi}  
[ext],  son(A, Ego), son(B, A), son(C, B), son(D, C), spouse(Alter, D).
;; 65
%fasuu:3, children:0, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoSoDaHu}  
[ext],  son(A, Ego), son(B, A), son(C, B), daughter(D, C), spouse(Alter, D).
;; 66
%fasuu:3, children:0, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoDaSoWi}  
[ext],  son(A, Ego), son(B, A), daughter(C, B), son(D, C), spouse(Alter, D).
;; 67
%fasuu:3, children:0, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoSoDaDaHu}  
[ext],  son(A, Ego), son(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D).
;; 68
%fasuu:3, children:0, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaSoSoWi}  
[ext],  son(A, Ego), daughter(B, A), son(C, B), son(D, C), spouse(Alter, D).
;; 69
%fasuu:3, children:0, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaSoDaHu}  
[ext],  son(A, Ego), daughter(B, A), son(C, B), daughter(D, C), spouse(Alter, D).
;; 70
%fasuu:3, children:0, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaDaSoWi}  
[ext],  son(A, Ego), daughter(B, A), daughter(C, B), son(D, C), spouse(Alter, D).
;; 71
%fasuu:3, children:0, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {SoDaDaDaHu}  
[ext],  son(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D).
;; 72
%fasuu:3, children:1, children:0, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoSoSoWi}  
[ext],  daughter(A, Ego), son(B, A), son(C, B), son(D, C), spouse(Alter, D).
;; 73
%fasuu:3, children:1, children:0, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoSoDaHu}  
[ext],  daughter(A, Ego), son(B, A), son(C, B), daughter(D, C), spouse(Alter, D).
;; 74
%fasuu:3, children:1, children:0, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoDaSoWi}  
[ext],  daughter(A, Ego), son(B, A), daughter(C, B), son(D, C), spouse(Alter, D).
;; 75
%fasuu:3, children:1, children:0, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaSoDaDaHu}  
[ext],  daughter(A, Ego), son(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D).
;; 76
%fasuu:3, children:1, children:1, children:0, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaSoSoWi}  
[ext],  daughter(A, Ego), daughter(B, A), son(C, B), son(D, C), spouse(Alter, D).
;; 77
%fasuu:3, children:1, children:1, children:0, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaSoDaHu}  
[ext],  daughter(A, Ego), daughter(B, A), son(C, B), daughter(D, C), spouse(Alter, D).
;; 78
%fasuu:3, children:1, children:1, children:1, children:0%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaDaSoWi}  
[ext],  daughter(A, Ego), daughter(B, A), daughter(C, B), son(D, C), spouse(Alter, D).
;; 79
%fasuu:3, children:1, children:1, children:1, children:1%
 Lvl=-4,  PC=4, S=1, Star=0,  {DaDaDaDaHu}  
[ext],  daughter(A, Ego), daughter(B, A), daughter(C, B), daughter(D, C), spouse(Alter, D).


fovo(Alter, Ego) :-  father(A, Ego), sibling(Alter, A), female(Alter).
{"FaSis"}
;; 0
%fovo:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {FaSis}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).


fovo_naiwo(Alter, Ego) :- [ext],  father(A, Ego), parents(B, A), generation[aux]27junior_smallGS(C, B), daughter(Alter, C).
                       |  [ext],  father(A, Ego), parents(B, A), generation[aux]27junior_smallGS(C, B), son(D, C), wife(Alter, D).
{"FaFaBroDa_FaFaBroSoWi_FaFaFaBroDaDa_FaFaFaBroDaSoWi_FaFaFaBroSoDa_FaFaFaBroSoSoWi_FaFaFaSisDaDa_FaFaFaSisDaSoWi_FaFaFaSisSoDa_FaFaFaSisSoSoWi_FaFaMoBroDaDa_FaFaMoBroDaSoWi_FaFaMoBroSoDa_FaFaMoBroSoSoWi_FaFaMoSisDaDa_FaFaMoSisDaSoWi_FaFaMoSisSoDa_FaFaMoSisSoSoWi_FaFaSisDa_FaFaSisSoWi_FaMoBroDa_FaMoBroSoWi_FaMoFaBroDaDa_FaMoFaBroDaSoWi_FaMoFaBroSoDa_FaMoFaBroSoSoWi_FaMoFaSisDaDa_FaMoFaSisDaSoWi_FaMoFaSisSoDa_FaMoFaSisSoSoWi_FaMoMoBroDaDa_FaMoMoBroDaSoWi_FaMoMoBroSoDa_FaMoMoBroSoSoWi_FaMoMoSisDaDa_FaMoMoSisDaSoWi_FaMoMoSisSoDa_FaMoMoSisSoSoWi_FaMoSisDa_FaMoSisSoWi"}
;; 0
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoBroDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(Alter, E).
;; 1
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoSisDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(Alter, E).
;; 2
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 3
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoBroDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 4
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoSisSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 5
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 6
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaBroSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 7
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaBroDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 8
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaSisSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 9
%fovo_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaSisDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 10
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaBroDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(Alter, E).
;; 11
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaSisDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(Alter, E).
;; 12
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoBroSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 13
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 14
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 15
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoSisDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 16
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaBroSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 17
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 18
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(Alter, G).
;; 19
%fovo_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaSisDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(Alter, G).
;; 20
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoBroSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), wife(Alter, F).
;; 21
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoSisSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), wife(Alter, F).
;; 22
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoBroSoSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 23
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoBroDaSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 24
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoSisSoSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 25
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoSisDaSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 26
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaBroSoSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 27
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaBroDaSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 28
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaSisSoSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 29
%fovo_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaSisDaSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 30
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaBroSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), wife(Alter, F).
;; 31
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaSisSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), wife(Alter, F).
;; 32
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoBroSoSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 33
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoBroDaSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 34
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoSisSoSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 35
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoSisDaSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 36
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaBroSoSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 37
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaBroDaSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 38
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaSisSoSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 39
%fovo_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaSisDaSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), wife(Alter, H).


fovo_navwer(Alter, Ego) :- [ext],  father(A, Ego), parents(B, A), generation[aux]27senior_smallGS(C, B), daughter(Alter, C).
                        |  [ext],  father(A, Ego), parents(B, A), generation[aux]27senior_smallGS(C, B), son(D, C), wife(Alter, D).
{"FaFaBroDa_FaFaBroSoWi_FaFaFaBroDaDa_FaFaFaBroDaSoWi_FaFaFaBroSoDa_FaFaFaBroSoSoWi_FaFaFaSisDaDa_FaFaFaSisDaSoWi_FaFaFaSisSoDa_FaFaFaSisSoSoWi_FaFaMoBroDaDa_FaFaMoBroDaSoWi_FaFaMoBroSoDa_FaFaMoBroSoSoWi_FaFaMoSisDaDa_FaFaMoSisDaSoWi_FaFaMoSisSoDa_FaFaMoSisSoSoWi_FaFaSisDa_FaFaSisSoWi_FaMoBroDa_FaMoBroSoWi_FaMoFaBroDaDa_FaMoFaBroDaSoWi_FaMoFaBroSoDa_FaMoFaBroSoSoWi_FaMoFaSisDaDa_FaMoFaSisDaSoWi_FaMoFaSisSoDa_FaMoFaSisSoSoWi_FaMoMoBroDaDa_FaMoMoBroDaSoWi_FaMoMoBroSoDa_FaMoMoBroSoSoWi_FaMoMoSisDaDa_FaMoMoSisDaSoWi_FaMoMoSisSoDa_FaMoMoSisSoSoWi_FaMoSisDa_FaMoSisSoWi"}
;; 0
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoBroDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(Alter, E).
;; 1
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoSisDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(Alter, E).
;; 2
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 3
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoBroDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 4
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoSisSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 5
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 6
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaBroSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 7
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaBroDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 8
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaSisSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 9
%fovo_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaMoFaSisDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 10
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaBroDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(Alter, E).
;; 11
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaSisDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(Alter, E).
;; 12
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoBroSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 13
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 14
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 15
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaMoSisDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 16
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaBroSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 17
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 18
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(Alter, G).
;; 19
%fovo_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {FaFaFaSisDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(Alter, G).
;; 20
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoBroSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), wife(Alter, F).
;; 21
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoSisSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), wife(Alter, F).
;; 22
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoBroSoSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 23
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoBroDaSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 24
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoSisSoSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 25
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoMoSisDaSoWi}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 26
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaBroSoSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 27
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaBroDaSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 28
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaSisSoSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 29
%fovo_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaMoFaSisDaSoWi}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 30
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaBroSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), wife(Alter, F).
;; 31
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaSisSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), wife(Alter, F).
;; 32
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoBroSoSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 33
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoBroDaSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 34
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoSisSoSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 35
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaMoSisDaSoWi}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 36
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaBroSoSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 37
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaBroDaSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).
;; 38
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaSisSoSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), wife(Alter, H).
;; 39
%fovo_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {FaFaFaSisDaSoWi}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), wife(Alter, H).


generation[aux]27(Alter, Ego) :-  sibling(Alter, Ego).
                              |   parents(A, Ego), generation[aux]27gs(B, A), child(Alter, B).
;; 0
%generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 4
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 5
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 6
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 7
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 8
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 9
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 10
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 11
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 12
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 13
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 14
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 15
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 16
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 17
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 18
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 19
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 20
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 21
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 22
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 23
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 24
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 25
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 26
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 27
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 28
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 29
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 30
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 31
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 32
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 33
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 34
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 35
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 36
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 37
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 38
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 39
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 40
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 41
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 42
%generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 43
%generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 44
%generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 45
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 46
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 47
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 48
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 49
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 50
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 51
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 52
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 53
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 54
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 55
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 56
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 57
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 58
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 59
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 60
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 61
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 62
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 63
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 64
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 65
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 66
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 67
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 68
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 69
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 70
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 71
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 72
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 73
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 74
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 75
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 76
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 77
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 78
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 79
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 80
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 81
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 82
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 83
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 84
%generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).


generation[aux]27gs(Alter, Ego) :-  siblings(Alter, Ego).
                                |   parents(A, Ego), generation[aux]27gs(B, A), children(Alter, B).
;; 0
%generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 7
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 8
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 9
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 10
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 11
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 12
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 13
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 14
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 15
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 16
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 17
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 18
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 19
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 20
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 21
%generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 22
%generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 23
%generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 24
%generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 25
%generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 26
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 27
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 28
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 29
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 30
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 31
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 32
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 33
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 34
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 35
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 36
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 37
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 38
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 39
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 40
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 41
%generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).


generation[aux]27junior(Alter, Ego) :-  sibling(Alter, Ego), younger(Alter, Ego).
                                    |   parents(A, Ego), generation[aux]27junior_gs(B, A), child(Alter, B).
;; 0
%generation[aux]27junior:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), younger(Alter, Ego).
;; 1
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), child(Alter, D).
;; 2
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), child(Alter, D).
;; 3
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), child(Alter, F).
;; 4
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 5
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), child(Alter, F).
;; 6
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 7
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 8
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 9
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 10
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 11
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 12
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 13
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 14
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 15
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 16
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 17
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 18
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 19
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 20
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 21
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 22
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 23
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), child(Alter, F).
;; 24
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 25
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), child(Alter, F).
;; 26
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 27
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 28
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 29
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 30
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 31
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 32
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 33
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 34
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 35
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 36
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 37
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 38
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 39
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 40
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 41
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 42
%generation[aux]27junior:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 43
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), child(Alter, D).
;; 44
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), child(Alter, D).
;; 45
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), child(Alter, F).
;; 46
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 47
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), child(Alter, F).
;; 48
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 49
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 50
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 51
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 52
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 53
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 54
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 55
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 56
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 57
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 58
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 59
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 60
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 61
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 62
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 63
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 64
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 65
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), child(Alter, F).
;; 66
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 67
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), child(Alter, F).
;; 68
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), child(Alter, F).
;; 69
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 70
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 71
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 72
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 73
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 74
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 75
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 76
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 77
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 78
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 79
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 80
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 81
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), child(Alter, H).
;; 82
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 83
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 84
%generation[aux]27junior:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), child(Alter, H).


generation[aux]27junior_gs(Alter, Ego) :-  siblings(Alter, Ego), younger(Alter, Ego).
                                       |   parents(A, Ego), generation[aux]27junior_gs(B, A), children(Alter, B).
;; 0
%generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), younger(Alter, Ego).
;; 1
%generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), younger(Alter, Ego).
;; 2
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), son(Alter, D).
;; 3
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), daughter(Alter, D).
;; 4
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), son(Alter, D).
;; 5
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), daughter(Alter, D).
;; 6
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 7
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 8
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 9
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 10
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 11
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 12
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 13
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 14
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 15
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 16
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 17
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 18
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 19
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 20
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 21
%generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 22
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), son(Alter, D).
;; 23
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), daughter(Alter, D).
;; 24
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), son(Alter, D).
;; 25
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), daughter(Alter, D).
;; 26
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 27
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 28
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 29
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 30
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 31
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 32
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 33
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 34
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 35
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 36
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 37
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 38
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 39
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 40
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 41
%generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).


generation[aux]27junior_small(Alter, Ego) :-  sibling(Alter, Ego), younger(Alter, Ego).
                                          |   parents(A, Ego), siblings(B, A), younger(B, A), child(Alter, B).
;; 0
%generation[aux]27junior_small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), younger(Alter, Ego).
;; 1
%generation[aux]27junior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), child(Alter, D).
;; 2
%generation[aux]27junior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), child(Alter, D).
;; 3
%generation[aux]27junior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), child(Alter, D).
;; 4
%generation[aux]27junior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), child(Alter, D).


generation[aux]27junior_smallGS(Alter, Ego) :-  siblings(Alter, Ego), younger(Alter, Ego).
                                            |   parents(A, Ego), siblings(B, A), younger(B, A), children(Alter, B).
;; 0
%generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), younger(Alter, Ego).
;; 1
%generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), younger(Alter, Ego).
;; 2
%generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), son(Alter, D).
;; 3
%generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), daughter(Alter, D).
;; 4
%generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), son(Alter, D).
;; 5
%generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), daughter(Alter, D).
;; 6
%generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), son(Alter, D).
;; 7
%generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), daughter(Alter, D).
;; 8
%generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), son(Alter, D).
;; 9
%generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), daughter(Alter, D).


generation[aux]27senior(Alter, Ego) :-  sibling(Alter, Ego), elder(Alter, Ego).
                                    |   parents(A, Ego), generation[aux]27senior_gs(B, A), child(Alter, B).
;; 0
%generation[aux]27senior:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), elder(Alter, Ego).
;; 1
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), child(Alter, D).
;; 2
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), child(Alter, D).
;; 3
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), child(Alter, F).
;; 4
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 5
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), child(Alter, F).
;; 6
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 7
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 8
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 9
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 10
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 11
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 12
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 13
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 14
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 15
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 16
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 17
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 18
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 19
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 20
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 21
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 22
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 23
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), child(Alter, F).
;; 24
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 25
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), child(Alter, F).
;; 26
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 27
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 28
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 29
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 30
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 31
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 32
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 33
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 34
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 35
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 36
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 37
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 38
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 39
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 40
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 41
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 42
%generation[aux]27senior:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 43
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), child(Alter, D).
;; 44
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), child(Alter, D).
;; 45
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), child(Alter, F).
;; 46
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 47
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), child(Alter, F).
;; 48
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 49
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 50
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 51
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 52
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 53
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 54
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 55
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 56
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 57
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 58
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 59
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 60
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 61
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 62
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 63
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 64
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 65
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), child(Alter, F).
;; 66
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 67
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), child(Alter, F).
;; 68
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), child(Alter, F).
;; 69
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 70
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 71
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 72
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 73
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 74
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 75
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 76
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 77
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 78
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 79
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 80
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).
;; 81
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(H, G), child(Alter, H).
;; 82
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), child(Alter, H).
;; 83
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(H, G), child(Alter, H).
;; 84
%generation[aux]27senior:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), child(Alter, H).


generation[aux]27senior_gs(Alter, Ego) :-  siblings(Alter, Ego), elder(Alter, Ego).
                                       |   parents(A, Ego), generation[aux]27senior_gs(B, A), children(Alter, B).
;; 0
%generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), elder(Alter, Ego).
;; 1
%generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), elder(Alter, Ego).
;; 2
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), son(Alter, D).
;; 3
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), daughter(Alter, D).
;; 4
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), son(Alter, D).
;; 5
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), daughter(Alter, D).
;; 6
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 7
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 8
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 9
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 10
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 11
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 12
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 13
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 14
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 15
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 16
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 17
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 18
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 19
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 20
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 21
%generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 22
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), son(Alter, D).
;; 23
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), daughter(Alter, D).
;; 24
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), son(Alter, D).
;; 25
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), daughter(Alter, D).
;; 26
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 27
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 28
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 29
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 30
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 31
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 32
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 33
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:0, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 34
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), son(Alter, F).
;; 35
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 36
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 37
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), daughter(Alter, F).
;; 38
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), son(Alter, F).
;; 39
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(F, E), daughter(Alter, F).
;; 40
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), son(Alter, F).
;; 41
%generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:1, parents:1, generation[aux]27senior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), daughter(Alter, F).


generation[aux]27senior_small(Alter, Ego) :-  sibling(Alter, Ego), elder(Alter, Ego).
                                          |   parents(A, Ego), siblings(B, A), elder(B, A), child(Alter, B).
;; 0
%generation[aux]27senior_small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), elder(Alter, Ego).
;; 1
%generation[aux]27senior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), child(Alter, D).
;; 2
%generation[aux]27senior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), child(Alter, D).
;; 3
%generation[aux]27senior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), child(Alter, D).
;; 4
%generation[aux]27senior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), child(Alter, D).


generation[aux]27senior_smallGS(Alter, Ego) :-  siblings(Alter, Ego), elder(Alter, Ego).
                                            |   parents(A, Ego), siblings(B, A), elder(B, A), children(Alter, B).
;; 0
%generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), elder(Alter, Ego).
;; 1
%generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), elder(Alter, Ego).
;; 2
%generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), son(Alter, D).
;; 3
%generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), daughter(Alter, D).
;; 4
%generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), son(Alter, D).
;; 5
%generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), daughter(Alter, D).
;; 6
%generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), son(Alter, D).
;; 7
%generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), elder(D, A), daughter(Alter, D).
;; 8
%generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), son(Alter, D).
;; 9
%generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), elder(D, A), daughter(Alter, D).


generation[aux]27small(Alter, Ego) :-  sibling(Alter, Ego).
                                   |   parents(A, Ego), siblings(B, A), child(Alter, B).
;; 0
%generation[aux]27small:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 4
%generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).


generation[aux]27smallGS(Alter, Ego) :-  siblings(Alter, Ego).
                                     |   parents(A, Ego), siblings(B, A), children(Alter, B).
;; 0
%generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).
;; 2
%generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 3
%generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 4
%generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 5
%generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 6
%generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 7
%generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 8
%generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 9
%generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).


half_brother(Alter, Ego) :-  mother(A, Ego), father(B, Ego), wife(C, B), son(Alter, C), son(Alter, B), not(equal(C, A)).
                         |   mother(A, Ego), father(B, Ego), husband(C, A), son(Alter, C), son(Alter, A), not(equal(C, B)).
;; 0
%half_brother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), wife(C, B), son(Alter, C), son(Alter, B), not(equal(C, A)).
;; 1
%half_brother:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), husband(C, A), son(Alter, C), son(Alter, A), not(equal(C, B)).


half_sister(Alter, Ego) :-  mother(A, Ego), father(B, Ego), wife(C, B), daughter(Alter, C), daughter(Alter, B), not(equal(C, A)).
                        |   mother(A, Ego), father(B, Ego), husband(C, A), daughter(Alter, C), daughter(Alter, A), not(equal(C, B)).
;; 0
%half_sister:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), wife(C, B), daughter(Alter, C), daughter(Alter, B), not(equal(C, A)).
;; 1
%half_sister:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), husband(C, A), daughter(Alter, C), daughter(Alter, A), not(equal(C, B)).


ina_naiwo(Alter, Ego) :- [ext],  mother(A, Ego), generation[aux]27junior_small(Alter, A), female(Alter).
                      |  [ext],  mother(A, Ego), generation[aux]27junior_small(B, A), wife(Alter, B).
{"MoBroWi_MoFaBroDa_MoFaBroSoWi_MoFaSisDa_MoFaSisSoWi_MoMoBroDa_MoMoBroSoWi_MoMoSisDa_MoMoSisSoWi_MoSis"}
;; 0
%ina_naiwo:0, generation[aux]27junior_small:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {MoSis}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), younger(Alter, A), female(Alter).
;; 1
%ina_naiwo:0, generation[aux]27junior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoBroDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(Alter, E), female(Alter).
;; 2
%ina_naiwo:0, generation[aux]27junior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoSisDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(Alter, E), female(Alter).
;; 3
%ina_naiwo:0, generation[aux]27junior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaBroDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(Alter, E), female(Alter).
;; 4
%ina_naiwo:0, generation[aux]27junior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaSisDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(Alter, E), female(Alter).
;; 5
%ina_naiwo:1, generation[aux]27junior_small:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {MoBroWi}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), younger(D, A), wife(Alter, D).
;; 6
%ina_naiwo:1, generation[aux]27junior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoBroSoWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(F, E), wife(Alter, F).
;; 7
%ina_naiwo:1, generation[aux]27junior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoSisSoWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(F, E), wife(Alter, F).
;; 8
%ina_naiwo:1, generation[aux]27junior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaBroSoWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(F, E), wife(Alter, F).
;; 9
%ina_naiwo:1, generation[aux]27junior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaSisSoWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(F, E), wife(Alter, F).


ina_naug(Alter, Ego) :-  mother(Alter, Ego).
{"Mo"}
;; 0
%ina_naug:0%
 Lvl=1,  PC=1, S=0, Star=0,  {Mo}  
 mother(Alter, Ego).


ina_navara(Alter, Ego) :-  step_mother(Alter, Ego).
{"Stmo"}
;; 0
%ina_navara:0, step_mother:0%
 Lvl=1,  PC=2, S=1, Star=0,  {Stmo}  
 father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).


ina_navwer(Alter, Ego) :- [ext],  mother(A, Ego), generation[aux]27senior_small(Alter, A), female(Alter).
                       |  [ext],  mother(A, Ego), generation[aux]27senior_small(B, A), wife(Alter, B).
{"MoBroWi_MoFaBroDa_MoFaBroSoWi_MoFaSisDa_MoFaSisSoWi_MoMoBroDa_MoMoBroSoWi_MoMoSisDa_MoMoSisSoWi_MoSis"}
;; 0
%ina_navwer:0, generation[aux]27senior_small:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {MoSis}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), elder(Alter, A), female(Alter).
;; 1
%ina_navwer:0, generation[aux]27senior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoBroDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(Alter, E), female(Alter).
;; 2
%ina_navwer:0, generation[aux]27senior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoSisDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(Alter, E), female(Alter).
;; 3
%ina_navwer:0, generation[aux]27senior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaBroDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(Alter, E), female(Alter).
;; 4
%ina_navwer:0, generation[aux]27senior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaSisDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(Alter, E), female(Alter).
;; 5
%ina_navwer:1, generation[aux]27senior_small:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {MoBroWi}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), elder(D, A), wife(Alter, D).
;; 6
%ina_navwer:1, generation[aux]27senior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoBroSoWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(F, E), wife(Alter, F).
;; 7
%ina_navwer:1, generation[aux]27senior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoSisSoWi}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(F, E), wife(Alter, F).
;; 8
%ina_navwer:1, generation[aux]27senior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaBroSoWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(F, E), wife(Alter, F).
;; 9
%ina_navwer:1, generation[aux]27senior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaSisSoWi}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(F, E), wife(Alter, F).


inavu(Alter, Ego) :-  wife(Alter, Ego).
{"Wi"}
;; 0
%inavu:0%
 Lvl=0,  PC=0, S=1, Star=0,  {Wi}  
 wife(Alter, Ego).


josiri(Alter, Ego) :-  siblings(Alter, Ego), younger(Alter, Ego).
                   |  [ext],  parents(A, Ego), generation[aux]27junior_gs(B, A), children(Alter, B).
{"Bro_FaBroDa_FaBroSo_FaFaBroDaDa_FaFaBroDaSo_FaFaBroSoDa_FaFaBroSoSo_FaFaFaBroDaDaDa_FaFaFaBroDaDaSo_FaFaFaBroDaSoDa_FaFaFaBroDaSoSo_FaFaFaBroSoDaDa_FaFaFaBroSoDaSo_FaFaFaBroSoSoDa_FaFaFaBroSoSoSo_FaFaFaSisDaDaDa_FaFaFaSisDaDaSo_FaFaFaSisDaSoDa_FaFaFaSisDaSoSo_FaFaFaSisSoDaDa_FaFaFaSisSoDaSo_FaFaFaSisSoSoDa_FaFaFaSisSoSoSo_FaFaMoBroDaDaDa_FaFaMoBroDaDaSo_FaFaMoBroDaSoDa_FaFaMoBroDaSoSo_FaFaMoBroSoDaDa_FaFaMoBroSoDaSo_FaFaMoBroSoSoDa_FaFaMoBroSoSoSo_FaFaMoSisDaDaDa_FaFaMoSisDaDaSo_FaFaMoSisDaSoDa_FaFaMoSisDaSoSo_FaFaMoSisSoDaDa_FaFaMoSisSoDaSo_FaFaMoSisSoSoDa_FaFaMoSisSoSoSo_FaFaSisDaDa_FaFaSisDaSo_FaFaSisSoDa_FaFaSisSoSo_FaMoBroDaDa_FaMoBroDaSo_FaMoBroSoDa_FaMoBroSoSo_FaMoFaBroDaDaDa_FaMoFaBroDaDaSo_FaMoFaBroDaSoDa_FaMoFaBroDaSoSo_FaMoFaBroSoDaDa_FaMoFaBroSoDaSo_FaMoFaBroSoSoDa_FaMoFaBroSoSoSo_FaMoFaSisDaDaDa_FaMoFaSisDaDaSo_FaMoFaSisDaSoDa_FaMoFaSisDaSoSo_FaMoFaSisSoDaDa_FaMoFaSisSoDaSo_FaMoFaSisSoSoDa_FaMoFaSisSoSoSo_FaMoMoBroDaDaDa_FaMoMoBroDaDaSo_FaMoMoBroDaSoDa_FaMoMoBroDaSoSo_FaMoMoBroSoDaDa_FaMoMoBroSoDaSo_FaMoMoBroSoSoDa_FaMoMoBroSoSoSo_FaMoMoSisDaDaDa_FaMoMoSisDaDaSo_FaMoMoSisDaSoDa_FaMoMoSisDaSoSo_FaMoMoSisSoDaDa_FaMoMoSisSoDaSo_FaMoMoSisSoSoDa_FaMoMoSisSoSoSo_FaMoSisDaDa_FaMoSisDaSo_FaMoSisSoDa_FaMoSisSoSo_FaSisDa_FaSisSo_MoBroDa_MoBroSo_MoFaBroDaDa_MoFaBroDaSo_MoFaBroSoDa_MoFaBroSoSo_MoFaFaBroDaDaDa_MoFaFaBroDaDaSo_MoFaFaBroDaSoDa_MoFaFaBroDaSoSo_MoFaFaBroSoDaDa_MoFaFaBroSoDaSo_MoFaFaBroSoSoDa_MoFaFaBroSoSoSo_MoFaFaSisDaDaDa_MoFaFaSisDaDaSo_MoFaFaSisDaSoDa_MoFaFaSisDaSoSo_MoFaFaSisSoDaDa_MoFaFaSisSoDaSo_MoFaFaSisSoSoDa_MoFaFaSisSoSoSo_MoFaMoBroDaDaDa_MoFaMoBroDaDaSo_MoFaMoBroDaSoDa_MoFaMoBroDaSoSo_MoFaMoBroSoDaDa_MoFaMoBroSoDaSo_MoFaMoBroSoSoDa_MoFaMoBroSoSoSo_MoFaMoSisDaDaDa_MoFaMoSisDaDaSo_MoFaMoSisDaSoDa_MoFaMoSisDaSoSo_MoFaMoSisSoDaDa_MoFaMoSisSoDaSo_MoFaMoSisSoSoDa_MoFaMoSisSoSoSo_MoFaSisDaDa_MoFaSisDaSo_MoFaSisSoDa_MoFaSisSoSo_MoMoBroDaDa_MoMoBroDaSo_MoMoBroSoDa_MoMoBroSoSo_MoMoFaBroDaDaDa_MoMoFaBroDaDaSo_MoMoFaBroDaSoDa_MoMoFaBroDaSoSo_MoMoFaBroSoDaDa_MoMoFaBroSoDaSo_MoMoFaBroSoSoDa_MoMoFaBroSoSoSo_MoMoFaSisDaDaDa_MoMoFaSisDaDaSo_MoMoFaSisDaSoDa_MoMoFaSisDaSoSo_MoMoFaSisSoDaDa_MoMoFaSisSoDaSo_MoMoFaSisSoSoDa_MoMoFaSisSoSoSo_MoMoMoBroDaDaDa_MoMoMoBroDaDaSo_MoMoMoBroDaSoDa_MoMoMoBroDaSoSo_MoMoMoBroSoDaDa_MoMoMoBroSoDaSo_MoMoMoBroSoSoDa_MoMoMoBroSoSoSo_MoMoMoSisDaDaDa_MoMoMoSisDaDaSo_MoMoMoSisDaSoDa_MoMoMoSisDaSoSo_MoMoMoSisSoDaDa_MoMoMoSisSoDaSo_MoMoMoSisSoSoDa_MoMoMoSisSoSoSo_MoMoSisDaDa_MoMoSisDaSo_MoMoSisSoDa_MoMoSisSoSo_MoSisDa_MoSisSo_Sis"}
;; 0
%josiri:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Bro}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter), younger(Alter, Ego).
;; 1
%josiri:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=0, Star=0,  {Sis}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter), younger(Alter, Ego).
;; 2
%josiri:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), son(Alter, D).
;; 3
%josiri:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {MoBroDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), daughter(Alter, D).
;; 4
%josiri:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), son(Alter, D).
;; 5
%josiri:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {MoSisDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), daughter(Alter, D).
;; 6
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 7
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 8
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 9
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoBroDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 10
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 11
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 12
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 13
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoMoSisDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 14
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 15
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 16
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 17
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 18
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 19
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 20
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 21
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoBroDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 22
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 23
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 24
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 25
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 26
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 27
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 28
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 29
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoMoSisDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 30
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 31
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 32
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 33
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 34
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 35
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 36
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 37
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaBroDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 38
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 39
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 40
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 41
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 42
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 43
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 44
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 45
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoMoFaSisDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 46
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 47
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 48
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 49
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaBroDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 50
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 51
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 52
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 53
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {MoFaSisDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 54
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 55
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 56
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 57
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroSoDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 58
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 59
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 60
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 61
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoBroDaDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 62
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 63
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 64
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 65
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisSoDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 66
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 67
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 68
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 69
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaMoSisDaDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 70
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 71
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 72
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 73
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroSoDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 74
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 75
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 76
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 77
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaBroDaDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 78
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 79
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 80
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 81
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisSoDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 82
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 83
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaSoDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 84
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 85
%josiri:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {MoFaFaSisDaDaDa}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 86
%josiri:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), son(Alter, D).
;; 87
%josiri:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {FaBroDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), younger(D, A), daughter(Alter, D).
;; 88
%josiri:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), son(Alter, D).
;; 89
%josiri:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=0, Star=0,  {FaSisDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), younger(D, A), daughter(Alter, D).
;; 90
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 91
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 92
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 93
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoBroDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 94
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 95
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 96
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 97
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaMoSisDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 98
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 99
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 100
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 101
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroSoDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 102
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 103
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 104
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 105
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoBroDaDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 106
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 107
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 108
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 109
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisSoDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 110
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 111
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 112
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 113
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoMoSisDaDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 114
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 115
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 116
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 117
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroSoDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 118
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 119
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 120
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 121
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaBroDaDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 122
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 123
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 124
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 125
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisSoDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 126
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 127
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 128
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 129
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaMoFaSisDaDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 130
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), son(Alter, F).
;; 131
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 132
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 133
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaBroDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 134
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), son(Alter, F).
;; 135
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(F, E), daughter(Alter, F).
;; 136
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), son(Alter, F).
;; 137
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=0, Star=0,  {FaFaSisDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), daughter(Alter, F).
;; 138
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 139
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 140
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 141
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroSoDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 142
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 143
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 144
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 145
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoBroDaDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 146
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 147
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 148
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 149
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisSoDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 150
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 151
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 152
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 153
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:0, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaMoSisDaDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 154
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 155
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 156
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 157
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroSoDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 158
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 159
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 160
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 161
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaBroDaDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 162
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), son(Alter, H).
;; 163
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(H, G), daughter(Alter, H).
;; 164
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), son(Alter, H).
;; 165
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisSoDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), daughter(Alter, H).
;; 166
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaSoSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), son(Alter, H).
;; 167
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaSoDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(H, G), daughter(Alter, H).
;; 168
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaDaSo}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), son(Alter, H).
;; 169
%josiri:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:1, parents:1, generation[aux]27junior_gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=0,  PC=10, S=0, Star=0,  {FaFaFaSisDaDaDa}  
[ext],  father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), daughter(Alter, H).


maru(Alter, Ego) :-  wife(Ego, A), sibling(A, B), wife(Alter, B).
                 |  [ext],  wife(Ego, A), parents(B, A), generation[aux]27smallGS(C, B), son(D, C), wife(Alter, D).
{"HuBroWi_HuFaBroSoWi_HuFaFaBroDaSoWi_HuFaFaBroSoSoWi_HuFaFaSisDaSoWi_HuFaFaSisSoSoWi_HuFaMoBroDaSoWi_HuFaMoBroSoSoWi_HuFaMoSisDaSoWi_HuFaMoSisSoSoWi_HuFaSisSoWi_HuMoBroSoWi_HuMoFaBroDaSoWi_HuMoFaBroSoSoWi_HuMoFaSisDaSoWi_HuMoFaSisSoSoWi_HuMoMoBroDaSoWi_HuMoMoBroSoSoWi_HuMoMoSisDaSoWi_HuMoMoSisSoSoWi_HuMoSisSoWi"}
;; 0
%maru:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuBroWi}  
 wife(Ego, A), mother(B, C), father(D, C), child(A, B), child(A, D), not(equal(A, C)), wife(Alter, C).
;; 1
%maru:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoBroSoWi}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), wife(Alter, F).
;; 2
%maru:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoSisSoWi}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), wife(Alter, F).
;; 3
%maru:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoBroSoSoWi}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), wife(Alter, H).
;; 4
%maru:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoBroDaSoWi}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 5
%maru:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoSisSoSoWi}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), wife(Alter, H).
;; 6
%maru:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoSisDaSoWi}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 7
%maru:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaBroSoSoWi}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), wife(Alter, H).
;; 8
%maru:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaBroDaSoWi}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 9
%maru:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaSisSoSoWi}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), wife(Alter, H).
;; 10
%maru:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaSisDaSoWi}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 11
%maru:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaBroSoWi}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), wife(Alter, F).
;; 12
%maru:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaSisSoWi}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), wife(Alter, F).
;; 13
%maru:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoBroSoSoWi}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), wife(Alter, H).
;; 14
%maru:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoBroDaSoWi}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 15
%maru:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoSisSoSoWi}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), wife(Alter, H).
;; 16
%maru:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoSisDaSoWi}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 17
%maru:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaBroSoSoWi}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), wife(Alter, H).
;; 18
%maru:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaBroDaSoWi}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), wife(Alter, H).
;; 19
%maru:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaSisSoSoWi}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), wife(Alter, H).
;; 20
%maru:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaSisDaSoWi}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), wife(Alter, H).


masara(Alter, Ego) :-  masara[aux]27(Alter, Ego).
                   |   masara[aux]27(Ego, Alter).
{"BroSoWi_FaBroDaSoWi_FaBroSoSoWi_FaSisDaSoWi_FaSisSoSoWi_HuBroSoWi_HuFa_HuFaBro_HuFaBroDaSoWi_HuFaBroSoSoWi_HuFaBroWi_HuFaFaBroDa_HuFaFaBroDaHu_HuFaFaBroSo_HuFaFaBroSoWi_HuFaFaSisDa_HuFaFaSisDaHu_HuFaFaSisSo_HuFaFaSisSoWi_HuFaMoBroDa_HuFaMoBroDaHu_HuFaMoBroSo_HuFaMoBroSoWi_HuFaMoSisDa_HuFaMoSisDaHu_HuFaMoSisSo_HuFaMoSisSoWi_HuFaSis_HuFaSisDaSoWi_HuFaSisHu_HuFaSisSoSoWi_HuMo_HuMoBro_HuMoBroDaSoWi_HuMoBroSoSoWi_HuMoBroWi_HuMoFaBroDa_HuMoFaBroDaHu_HuMoFaBroSo_HuMoFaBroSoWi_HuMoFaSisDa_HuMoFaSisDaHu_HuMoFaSisSo_HuMoFaSisSoWi_HuMoMoBroDa_HuMoMoBroDaHu_HuMoMoBroSo_HuMoMoBroSoWi_HuMoMoSisDa_HuMoMoSisDaHu_HuMoMoSisSo_HuMoMoSisSoWi_HuMoSis_HuMoSisDaSoWi_HuMoSisHu_HuMoSisSoSoWi_HuSisSoWi_MoBroDaSoWi_MoBroSoSoWi_MoSisDaSoWi_MoSisSoSoWi_SisSoWi_SoWi_WiBroSoWi_WiFaBroDaSoWi_WiFaBroSoSoWi_WiFaSisDaSoWi_WiFaSisSoSoWi_WiMoBroDaSoWi_WiMoBroSoSoWi_WiMoSisDaSoWi_WiMoSisSoSoWi_WiSisSoWi"}
;; 0
%masara:0, masara[aux]27:0, parents:0%
 Lvl=1,  PC=1, S=1, Star=0,  {HuMo}  
 husband(A, Ego), mother(Alter, A).
;; 1
%masara:0, masara[aux]27:0, parents:1%
 Lvl=1,  PC=1, S=1, Star=0,  {HuFa}  
 husband(A, Ego), father(Alter, A).
;; 2
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuMoBro}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 3
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuMoSis}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 4
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoBroSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 5
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoBroDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 6
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoSisSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 7
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoMoSisDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 8
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaBroSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 9
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaBroDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 10
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaSisSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 11
%masara:0, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuMoFaSisDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 12
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuFaBro}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 13
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {HuFaSis}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 14
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoBroSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 15
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoBroDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 16
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoSisSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 17
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaMoSisDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 18
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaBroSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 19
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaBroDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 20
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaSisSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 21
%masara:0, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=7, S=1, Star=0,  {HuFaFaSisDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 22
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=1,  PC=5, S=2, Star=0,  {HuMoSisHu}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 23
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=1,  PC=5, S=2, Star=0,  {HuMoBroWi}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 24
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoMoBroDaHu}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 25
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoMoBroSoWi}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 26
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoMoSisDaHu}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 27
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoMoSisSoWi}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 28
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoFaBroDaHu}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 29
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoFaBroSoWi}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 30
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoFaSisDaHu}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 31
%masara:0, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuMoFaSisSoWi}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 32
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=1,  PC=5, S=2, Star=0,  {HuFaSisHu}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 33
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=1,  PC=5, S=2, Star=0,  {HuFaBroWi}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 34
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaMoBroDaHu}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 35
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaMoBroSoWi}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 36
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaMoSisDaHu}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 37
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaMoSisSoWi}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 38
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaFaBroDaHu}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 39
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaFaBroSoWi}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 40
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaFaSisDaHu}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 41
%masara:0, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=1,  PC=7, S=2, Star=0,  {HuFaFaSisSoWi}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 42
%masara:1, masara[aux]27:0, parents:0%
 Lvl=-1,  PC=1, S=1, Star=0,  {SoWi}  
 husband(A, Alter), mother(Ego, A).
;; 43
%masara:1, masara[aux]27:0, parents:1%
 Lvl=-1,  PC=1, S=1, Star=0,  {SoWi}  
 husband(A, Alter), father(Ego, A).
;; 44
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 45
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {SisSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 46
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 47
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 48
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 49
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 50
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 51
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 52
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 53
%masara:1, masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 54
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), male(Ego).
;; 55
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {BroSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), father(D, B), child(Ego, C), child(Ego, D), not(equal(Ego, B)), female(Ego).
;; 56
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 57
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 58
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 59
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 60
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Ego, F).
;; 61
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {FaBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Ego, F).
;; 62
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Ego, F).
;; 63
%masara:1, masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {MoBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Ego, F).
;; 64
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=-1,  PC=5, S=2, Star=0,  {WiSisSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Ego, E).
;; 65
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=-1,  PC=5, S=2, Star=0,  {HuSisSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Ego, E).
;; 66
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 67
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 68
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 69
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoSisDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).
;; 70
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 71
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 72
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 73
%masara:1, masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoBroDaSoWi}  
[ext],  husband(A, Alter), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).
;; 74
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=-1,  PC=5, S=2, Star=0,  {WiBroSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Ego, E).
;; 75
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=-1,  PC=5, S=2, Star=0,  {HuBroSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Ego, E).
;; 76
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 77
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 78
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 79
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoSisSoSoWi}  
[ext],  husband(A, Alter), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).
;; 80
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiFaBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Ego, G).
;; 81
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuFaBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Ego, G).
;; 82
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=-1,  PC=7, S=2, Star=0,  {WiMoBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Ego, G).
;; 83
%masara:1, masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=-1,  PC=7, S=2, Star=0,  {HuMoBroSoSoWi}  
[ext],  husband(A, Alter), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Ego, G).


masara[aux]27(Alter, Ego) :-  husband(A, Ego), parents(Alter, A).
                          |  [ext],  husband(A, Ego), parents(B, A), generation[aux]27smallGS(Alter, B).
                          |  [ext],  husband(A, Ego), parents(B, A), generation[aux]27small(C, B), spice(Alter, C).
;; 0
%masara[aux]27:0, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), mother(Alter, A).
;; 1
%masara[aux]27:0, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(A, Ego), father(Alter, A).
;; 2
%masara[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 3
%masara[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 4
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 5
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 6
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 7
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 8
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 9
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 10
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 11
%masara[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 12
%masara[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), male(Alter).
;; 13
%masara[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)), female(Alter).
;; 14
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 15
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 16
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 17
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 18
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(Alter, F).
;; 19
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(Alter, F).
;; 20
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(Alter, F).
;; 21
%masara[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(Alter, F).
;; 22
%masara[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 23
%masara[aux]27:2, parents:0, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 24
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 25
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 26
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 27
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 28
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 29
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 30
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 31
%masara[aux]27:2, parents:0, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 32
%masara[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), husband(Alter, E).
;; 33
%masara[aux]27:2, parents:1, generation[aux]27small:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), wife(Alter, E).
;; 34
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 35
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 36
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 37
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:0, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).
;; 38
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), husband(Alter, G).
;; 39
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:0, brother:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(G, F), wife(Alter, G).
;; 40
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), husband(Alter, G).
;; 41
%masara[aux]27:2, parents:1, generation[aux]27small:1, parents:1, siblings:1, sister:0, sibling:0, spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(G, F), wife(Alter, G).


mem(Alter, Ego) :-  mother(A, Ego), sibling(Alter, A), male(Alter).
{"MoBro"}
;; 0
%mem:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {MoBro}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).


mem_naiwo(Alter, Ego) :- [ext],  mother(A, Ego), parents(B, A), generation[aux]27junior_smallGS(C, B), son(Alter, C).
                      |  [ext],  mother(A, Ego), parents(B, A), generation[aux]27junior_smallGS(C, B), daughter(D, C), husband(Alter, D).
{"MoFaBroDaHu_MoFaBroSo_MoFaFaBroDaDaHu_MoFaFaBroDaSo_MoFaFaBroSoDaHu_MoFaFaBroSoSo_MoFaFaSisDaDaHu_MoFaFaSisDaSo_MoFaFaSisSoDaHu_MoFaFaSisSoSo_MoFaMoBroDaDaHu_MoFaMoBroDaSo_MoFaMoBroSoDaHu_MoFaMoBroSoSo_MoFaMoSisDaDaHu_MoFaMoSisDaSo_MoFaMoSisSoDaHu_MoFaMoSisSoSo_MoFaSisDaHu_MoFaSisSo_MoMoBroDaHu_MoMoBroSo_MoMoFaBroDaDaHu_MoMoFaBroDaSo_MoMoFaBroSoDaHu_MoMoFaBroSoSo_MoMoFaSisDaDaHu_MoMoFaSisDaSo_MoMoFaSisSoDaHu_MoMoFaSisSoSo_MoMoMoBroDaDaHu_MoMoMoBroDaSo_MoMoMoBroSoDaHu_MoMoMoBroSoSo_MoMoMoSisDaDaHu_MoMoMoSisDaSo_MoMoMoSisSoDaHu_MoMoMoSisSoSo_MoMoSisDaHu_MoMoSisSo"}
;; 0
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoBroSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(Alter, E).
;; 1
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoSisSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(Alter, E).
;; 2
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(Alter, G).
;; 3
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 4
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(Alter, G).
;; 5
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 6
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(Alter, G).
;; 7
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 8
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(Alter, G).
;; 9
%mem_naiwo:0, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 10
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaBroSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), son(Alter, E).
;; 11
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaSisSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), son(Alter, E).
;; 12
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(Alter, G).
;; 13
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoBroDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 14
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoSisSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(Alter, G).
;; 15
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 16
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), son(Alter, G).
;; 17
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaBroDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 18
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaSisSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), son(Alter, G).
;; 19
%mem_naiwo:0, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), son(Alter, G).
;; 20
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoBroDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), husband(Alter, F).
;; 21
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoSisDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), husband(Alter, F).
;; 22
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoBroSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 23
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoBroDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 24
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoSisSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 25
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoSisDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 26
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaBroSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 27
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaBroDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 28
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaSisSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 29
%mem_naiwo:1, parents:0, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaSisDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 30
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaBroDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), daughter(F, E), husband(Alter, F).
;; 31
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaSisDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), daughter(F, E), husband(Alter, F).
;; 32
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoBroSoDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 33
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoBroDaDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 34
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoSisSoDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 35
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoSisDaDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 36
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaBroSoDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 37
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaBroDaDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 38
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaSisSoDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 39
%mem_naiwo:1, parents:1, generation[aux]27junior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaSisDaDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), younger(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).


mem_navwer(Alter, Ego) :- [ext],  mother(A, Ego), parents(B, A), generation[aux]27senior_smallGS(C, B), son(Alter, C).
                       |  [ext],  mother(A, Ego), parents(B, A), generation[aux]27senior_smallGS(C, B), daughter(D, C), husband(Alter, D).
{"MoFaBroDaHu_MoFaBroSo_MoFaFaBroDaDaHu_MoFaFaBroDaSo_MoFaFaBroSoDaHu_MoFaFaBroSoSo_MoFaFaSisDaDaHu_MoFaFaSisDaSo_MoFaFaSisSoDaHu_MoFaFaSisSoSo_MoFaMoBroDaDaHu_MoFaMoBroDaSo_MoFaMoBroSoDaHu_MoFaMoBroSoSo_MoFaMoSisDaDaHu_MoFaMoSisDaSo_MoFaMoSisSoDaHu_MoFaMoSisSoSo_MoFaSisDaHu_MoFaSisSo_MoMoBroDaHu_MoMoBroSo_MoMoFaBroDaDaHu_MoMoFaBroDaSo_MoMoFaBroSoDaHu_MoMoFaBroSoSo_MoMoFaSisDaDaHu_MoMoFaSisDaSo_MoMoFaSisSoDaHu_MoMoFaSisSoSo_MoMoMoBroDaDaHu_MoMoMoBroDaSo_MoMoMoBroSoDaHu_MoMoMoBroSoSo_MoMoMoSisDaDaHu_MoMoMoSisDaSo_MoMoMoSisSoDaHu_MoMoMoSisSoSo_MoMoSisDaHu_MoMoSisSo"}
;; 0
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoBroSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(Alter, E).
;; 1
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoMoSisSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(Alter, E).
;; 2
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(Alter, G).
;; 3
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 4
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(Alter, G).
;; 5
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoMoSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 6
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(Alter, G).
;; 7
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 8
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(Alter, G).
;; 9
%mem_navwer:0, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoMoFaSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 10
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaBroSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), son(Alter, E).
;; 11
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {MoFaSisSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), son(Alter, E).
;; 12
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoBroSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(Alter, G).
;; 13
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoBroDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 14
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoSisSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(Alter, G).
;; 15
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaMoSisDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 16
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaBroSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), son(Alter, G).
;; 17
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaBroDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 18
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaSisSoSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), son(Alter, G).
;; 19
%mem_navwer:0, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=0, Star=0,  {MoFaFaSisDaSo}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), son(Alter, G).
;; 20
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoBroDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), husband(Alter, F).
;; 21
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoMoSisDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), husband(Alter, F).
;; 22
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoBroSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 23
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoBroDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 24
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoSisSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 25
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoMoSisDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 26
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaBroSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 27
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaBroDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 28
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaSisSoDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 29
%mem_navwer:1, parents:0, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoMoFaSisDaDaHu}  
[ext],  mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 30
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaBroDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), daughter(F, E), husband(Alter, F).
;; 31
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {MoFaSisDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), daughter(F, E), husband(Alter, F).
;; 32
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoBroSoDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 33
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoBroDaDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 34
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoSisSoDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 35
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaMoSisDaDaHu}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 36
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaBroSoDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 37
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaBroDaDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 38
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaSisSoDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), son(G, F), daughter(H, G), husband(Alter, H).
;; 39
%mem_navwer:1, parents:1, generation[aux]27senior_smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=1,  PC=9, S=1, Star=0,  {MoFaFaSisDaDaHu}  
[ext],  mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), elder(F, C), daughter(G, F), daughter(H, G), husband(Alter, H).


nani_naiwo(Alter, Ego) :- [ext],  father(A, Ego), generation[aux]27junior_small(Alter, A), male(Alter).
                       |  [ext],  father(A, Ego), generation[aux]27junior_small(B, A), husband(Alter, B).
{"FaBro_FaFaBroDaHu_FaFaBroSo_FaFaSisDaHu_FaFaSisSo_FaMoBroDaHu_FaMoBroSo_FaMoSisDaHu_FaMoSisSo_FaSisHu"}
;; 0
%nani_naiwo:0, generation[aux]27junior_small:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {FaBro}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), younger(Alter, A), male(Alter).
;; 1
%nani_naiwo:0, generation[aux]27junior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoBroSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(Alter, E), male(Alter).
;; 2
%nani_naiwo:0, generation[aux]27junior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoSisSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(Alter, E), male(Alter).
;; 3
%nani_naiwo:0, generation[aux]27junior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaBroSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(Alter, E), male(Alter).
;; 4
%nani_naiwo:0, generation[aux]27junior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaSisSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(Alter, E), male(Alter).
;; 5
%nani_naiwo:1, generation[aux]27junior_small:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {FaSisHu}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), younger(D, A), husband(Alter, D).
;; 6
%nani_naiwo:1, generation[aux]27junior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoBroDaHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(F, E), husband(Alter, F).
;; 7
%nani_naiwo:1, generation[aux]27junior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoSisDaHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(F, E), husband(Alter, F).
;; 8
%nani_naiwo:1, generation[aux]27junior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaBroDaHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), younger(E, B), child(F, E), husband(Alter, F).
;; 9
%nani_naiwo:1, generation[aux]27junior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaSisDaHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), younger(E, B), child(F, E), husband(Alter, F).


nani_naug(Alter, Ego) :-  father(Alter, Ego).
{"Fa"}
;; 0
%nani_naug:0%
 Lvl=1,  PC=1, S=0, Star=0,  {Fa}  
 father(Alter, Ego).


nani_navara(Alter, Ego) :-  step_father(Alter, Ego).
{"Stfa"}
;; 0
%nani_navara:0, step_father:0%
 Lvl=1,  PC=2, S=1, Star=0,  {Stfa}  
 father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).


nani_navwer(Alter, Ego) :- [ext],  father(A, Ego), generation[aux]27senior_small(Alter, A), male(Alter).
                        |  [ext],  father(A, Ego), generation[aux]27senior_small(B, A), husband(Alter, B).
{"FaBro_FaFaBroDaHu_FaFaBroSo_FaFaSisDaHu_FaFaSisSo_FaMoBroDaHu_FaMoBroSo_FaMoSisDaHu_FaMoSisSo_FaSisHu"}
;; 0
%nani_navwer:0, generation[aux]27senior_small:0, sibling:0%
 Lvl=1,  PC=5, S=0, Star=0,  {FaBro}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), elder(Alter, A), male(Alter).
;; 1
%nani_navwer:0, generation[aux]27senior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoBroSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(Alter, E), male(Alter).
;; 2
%nani_navwer:0, generation[aux]27senior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaMoSisSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(Alter, E), male(Alter).
;; 3
%nani_navwer:0, generation[aux]27senior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaBroSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(Alter, E), male(Alter).
;; 4
%nani_navwer:0, generation[aux]27senior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=0, Star=0,  {FaFaSisSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(Alter, E), male(Alter).
;; 5
%nani_navwer:1, generation[aux]27senior_small:0, sibling:0%
 Lvl=1,  PC=5, S=1, Star=0,  {FaSisHu}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), elder(D, A), husband(Alter, D).
;; 6
%nani_navwer:1, generation[aux]27senior_small:1, parents:0, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoBroDaHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(F, E), husband(Alter, F).
;; 7
%nani_navwer:1, generation[aux]27senior_small:1, parents:0, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaMoSisDaHu}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(F, E), husband(Alter, F).
;; 8
%nani_navwer:1, generation[aux]27senior_small:1, parents:1, siblings:0, brother:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaBroDaHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), elder(E, B), child(F, E), husband(Alter, F).
;; 9
%nani_navwer:1, generation[aux]27senior_small:1, parents:1, siblings:1, sister:0, sibling:0%
 Lvl=1,  PC=7, S=1, Star=0,  {FaFaSisDaHu}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), elder(E, B), child(F, E), husband(Alter, F).


ne_eri(Alter, Ego) :-  ne_eri[aux]27(Alter, Ego).
                   |   ne_eri[aux]27(Ego, Alter).
{"BroWi_FaBroSoWi_FaFaBroDaSoWi_FaFaBroSoSoWi_FaFaSisDaSoWi_FaFaSisSoSoWi_FaMoBroDaSoWi_FaMoBroSoSoWi_FaMoSisDaSoWi_FaMoSisSoSoWi_FaSisSoWi_HuFaBroDa_HuFaFaBroDaDa_HuFaFaBroSoDa_HuFaFaSisDaDa_HuFaFaSisSoDa_HuFaMoBroDaDa_HuFaMoBroSoDa_HuFaMoSisDaDa_HuFaMoSisSoDa_HuFaSisDa_HuMoBroDa_HuMoFaBroDaDa_HuMoFaBroSoDa_HuMoFaSisDaDa_HuMoFaSisSoDa_HuMoMoBroDaDa_HuMoMoBroSoDa_HuMoMoSisDaDa_HuMoMoSisSoDa_HuMoSisDa_HuSis_MoBroSoWi_MoFaBroDaSoWi_MoFaBroSoSoWi_MoFaSisDaSoWi_MoFaSisSoSoWi_MoMoBroDaSoWi_MoMoBroSoSoWi_MoMoSisDaSoWi_MoMoSisSoSoWi_MoSisSoWi"}
;; 0
%ne_eri:0, ne_eri[aux]27:0, sister:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {HuSis}  
 wife(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 1
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoBroDa}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 2
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoSisDa}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 3
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoBroSoDa}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 4
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoBroDaDa}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 5
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoSisSoDa}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 6
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoSisDaDa}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 7
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaBroSoDa}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 8
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaBroDaDa}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 9
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaSisSoDa}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 10
%ne_eri:0, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaSisDaDa}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 11
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaBroDa}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 12
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaSisDa}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 13
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoBroSoDa}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 14
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoBroDaDa}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 15
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoSisSoDa}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 16
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoSisDaDa}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 17
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaBroSoDa}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 18
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaBroDaDa}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 19
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaSisSoDa}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 20
%ne_eri:0, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaSisDaDa}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 21
%ne_eri:1, ne_eri[aux]27:0, sister:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {BroWi}  
 wife(Alter, A), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), female(Ego).
;; 22
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaSisSoWi}  
[ext],  wife(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Ego, E).
;; 23
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoSisSoWi}  
[ext],  wife(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Ego, E).
;; 24
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 25
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 26
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 27
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 28
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 29
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 30
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 31
%ne_eri:1, ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroDaSoWi}  
[ext],  wife(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 32
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaBroSoWi}  
[ext],  wife(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Ego, E).
;; 33
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoBroSoWi}  
[ext],  wife(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Ego, E).
;; 34
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisSoSoWi}  
[ext],  wife(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 35
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisSoSoWi}  
[ext],  wife(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 36
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisSoSoWi}  
[ext],  wife(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 37
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisSoSoWi}  
[ext],  wife(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 38
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroSoSoWi}  
[ext],  wife(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 39
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroSoSoWi}  
[ext],  wife(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 40
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroSoSoWi}  
[ext],  wife(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 41
%ne_eri:1, ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroSoSoWi}  
[ext],  wife(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).


ne_eri[aux]27(Alter, Ego) :-  wife(Ego, A), sister(Alter, A).
                          |  [ext],  wife(Ego, A), parents(B, A), generation[aux]27smallGS(C, B), daughter(Alter, C).
;; 0
%ne_eri[aux]27:0, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 1
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 2
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 3
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 4
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 5
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 6
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 7
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 8
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 9
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 10
%ne_eri[aux]27:1, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 11
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 12
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 13
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 14
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 15
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 16
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 17
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 18
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 19
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 20
%ne_eri[aux]27:1, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).


nevu(Alter, Ego) :-  nevu[aux]27(Alter, Ego).
                 |   nevu[aux]27(Ego, Alter).
{"FaBroDaHu_FaFaBroDaDaHu_FaFaBroSoDaHu_FaFaSisDaDaHu_FaFaSisSoDaHu_FaMoBroDaDaHu_FaMoBroSoDaHu_FaMoSisDaDaHu_FaMoSisSoDaHu_FaSisDaHu_MoBroDaHu_MoFaBroDaDaHu_MoFaBroSoDaHu_MoFaSisDaDaHu_MoFaSisSoDaHu_MoMoBroDaDaHu_MoMoBroSoDaHu_MoMoSisDaDaHu_MoMoSisSoDaHu_MoSisDaHu_SisHu_WiBro_WiFaBroDa_WiFaBroDaHu_WiFaBroSo_WiFaFaBroDaDa_WiFaFaBroDaDaHu_WiFaFaBroDaSo_WiFaFaBroSoDa_WiFaFaBroSoDaHu_WiFaFaBroSoSo_WiFaFaSisDaDa_WiFaFaSisDaDaHu_WiFaFaSisDaSo_WiFaFaSisSoDa_WiFaFaSisSoDaHu_WiFaFaSisSoSo_WiFaMoBroDaDa_WiFaMoBroDaDaHu_WiFaMoBroDaSo_WiFaMoBroSoDa_WiFaMoBroSoDaHu_WiFaMoBroSoSo_WiFaMoSisDaDa_WiFaMoSisDaDaHu_WiFaMoSisDaSo_WiFaMoSisSoDa_WiFaMoSisSoDaHu_WiFaMoSisSoSo_WiFaSisDa_WiFaSisDaHu_WiFaSisSo_WiMoBroDa_WiMoBroDaHu_WiMoBroSo_WiMoFaBroDaDa_WiMoFaBroDaDaHu_WiMoFaBroDaSo_WiMoFaBroSoDa_WiMoFaBroSoDaHu_WiMoFaBroSoSo_WiMoFaSisDaDa_WiMoFaSisDaDaHu_WiMoFaSisDaSo_WiMoFaSisSoDa_WiMoFaSisSoDaHu_WiMoFaSisSoSo_WiMoMoBroDaDa_WiMoMoBroDaDaHu_WiMoMoBroDaSo_WiMoMoBroSoDa_WiMoMoBroSoDaHu_WiMoMoBroSoSo_WiMoMoSisDaDa_WiMoMoSisDaDaHu_WiMoMoSisDaSo_WiMoMoSisSoDa_WiMoMoSisSoDaHu_WiMoMoSisSoSo_WiMoSisDa_WiMoSisDaHu_WiMoSisSo_WiSis_WiSisHu"}
;; 0
%nevu:0, nevu[aux]27:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {WiBro}  
 husband(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 1
%nevu:0, nevu[aux]27:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {WiSis}  
 husband(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 2
%nevu:0, nevu[aux]27:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiSisHu}  
[ext],  husband(Ego, A), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), husband(Alter, D).
;; 3
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroSo}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 4
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroDa}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 5
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoSisSo}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 6
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoSisDa}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 7
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoBroSoSo}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 8
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoBroSoDa}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 9
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoBroDaSo}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 10
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoBroDaDa}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 11
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoSisSoSo}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 12
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoSisSoDa}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 13
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoSisDaSo}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 14
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoSisDaDa}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 15
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaBroSoSo}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 16
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaBroSoDa}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 17
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaBroDaSo}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 18
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaBroDaDa}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 19
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaSisSoSo}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 20
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaSisSoDa}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 21
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaSisDaSo}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 22
%nevu:0, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaSisDaDa}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 23
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaBroSo}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 24
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaBroDa}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 25
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisSo}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 26
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisDa}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 27
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoBroSoSo}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 28
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoBroSoDa}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 29
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoBroDaSo}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 30
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoBroDaDa}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 31
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoSisSoSo}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 32
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoSisSoDa}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 33
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoSisDaSo}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 34
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoSisDaDa}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 35
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaBroSoSo}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 36
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaBroSoDa}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 37
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaBroDaSo}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 38
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaBroDaDa}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 39
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaSisSoSo}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 40
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaSisSoDa}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 41
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaSisDaSo}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 42
%nevu:0, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaSisDaDa}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 43
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoBroDaHu}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), husband(Alter, F).
;; 44
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoSisDaHu}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), husband(Alter, F).
;; 45
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoBroSoDaHu}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 46
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoBroDaDaHu}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 47
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoSisSoDaHu}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 48
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoSisDaDaHu}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 49
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaBroSoDaHu}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 50
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaBroDaDaHu}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 51
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaSisSoDaHu}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 52
%nevu:0, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaSisDaDaHu}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 53
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaBroDaHu}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), husband(Alter, F).
;; 54
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaSisDaHu}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), husband(Alter, F).
;; 55
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoBroSoDaHu}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 56
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoBroDaDaHu}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 57
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoSisSoDaHu}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 58
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoSisDaDaHu}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 59
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaBroSoDaHu}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 60
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaBroDaDaHu}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 61
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaSisSoDaHu}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 62
%nevu:0, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaSisDaDaHu}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 63
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoBroDaHu}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), husband(Alter, E).
;; 64
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoSisDaHu}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), husband(Alter, E).
;; 65
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroSoDaHu}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 66
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroDaDaHu}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 67
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisSoDaHu}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 68
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisDaDaHu}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 69
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroSoDaHu}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 70
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroDaDaHu}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 71
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisSoDaHu}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 72
%nevu:0, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisDaDaHu}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 73
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaBroDaHu}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), husband(Alter, E).
;; 74
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaSisDaHu}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), husband(Alter, E).
;; 75
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroSoDaHu}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 76
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroDaDaHu}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 77
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisSoDaHu}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 78
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisDaDaHu}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 79
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroSoDaHu}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 80
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroDaDaHu}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 81
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisSoDaHu}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 82
%nevu:0, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisDaDaHu}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 83
%nevu:1, nevu[aux]27:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {SisHu}  
 husband(Alter, A), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), male(Ego).
;; 84
%nevu:1, nevu[aux]27:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {SisHu}  
 husband(Alter, A), mother(B, A), father(C, A), child(Ego, B), child(Ego, C), not(equal(Ego, A)), female(Ego).
;; 85
%nevu:1, nevu[aux]27:1, sister:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {WiSisHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), husband(Ego, D).
;; 86
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaSisDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Ego, E).
;; 87
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {FaSisDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Ego, E).
;; 88
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoSisDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Ego, E).
;; 89
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {MoSisDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Ego, E).
;; 90
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Ego, G).
;; 91
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 92
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Ego, G).
;; 93
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 94
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Ego, G).
;; 95
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 96
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Ego, G).
;; 97
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 98
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Ego, G).
;; 99
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 100
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Ego, G).
;; 101
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 102
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Ego, G).
;; 103
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 104
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Ego, G).
;; 105
%nevu:1, nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 106
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaBroDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Ego, E).
;; 107
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {FaBroDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Ego, E).
;; 108
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoBroDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Ego, E).
;; 109
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=6, S=1, Star=0,  {MoBroDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Ego, E).
;; 110
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Ego, G).
;; 111
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 112
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Ego, G).
;; 113
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 114
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Ego, G).
;; 115
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 116
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Ego, G).
;; 117
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 118
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Ego, G).
;; 119
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Ego, G).
;; 120
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Ego, G).
;; 121
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Ego, G).
;; 122
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Ego, G).
;; 123
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Ego, G).
;; 124
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Ego, G).
;; 125
%nevu:1, nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Ego, G).
;; 126
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaSisDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), husband(Ego, F).
;; 127
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoSisDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), husband(Ego, F).
;; 128
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 129
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 130
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 131
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoSisDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 132
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 133
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 134
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 135
%nevu:1, nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoBroDaDaHu}  
[ext],  husband(Alter, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 136
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiFaBroDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), husband(Ego, F).
;; 137
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {WiMoBroDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), husband(Ego, F).
;; 138
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 139
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 140
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 141
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoSisSoDaHu}  
[ext],  husband(Alter, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 142
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaFaBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 143
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoFaBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 144
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {WiFaMoBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Ego, H).
;; 145
%nevu:1, nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {WiMoMoBroSoDaHu}  
[ext],  husband(Alter, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Ego, H).
;; 146
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaSisSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), husband(Ego, E).
;; 147
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoSisSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), husband(Ego, E).
;; 148
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaSisDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 149
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaSisDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 150
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoSisDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 151
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoSisDaSo}  
[ext],  male(Alter), mother(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 152
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaBroDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 153
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaBroDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 154
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoBroDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 155
%nevu:1, nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoBroDaSo}  
[ext],  male(Alter), mother(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 156
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiFaBroSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), husband(Ego, E).
;; 157
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {WiMoBroSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), husband(Ego, E).
;; 158
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaSisSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 159
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaSisSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 160
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoSisSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 161
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoSisSoSo}  
[ext],  male(Alter), father(A, Alter), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 162
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaFaBroSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 163
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoFaBroSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Ego, G).
;; 164
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {WiFaMoBroSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Ego, G).
;; 165
%nevu:1, nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {WiMoMoBroSoSo}  
[ext],  male(Alter), father(A, Alter), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Ego, G).


nevu[aux]27(Alter, Ego) :-  husband(Ego, A), siblings(Alter, A).
                        |  [ext],  husband(Ego, A), sister(B, A), husband(Alter, B).
                        |  [ext],  husband(Ego, A), parents(B, A), generation[aux]27smallGS(C, B), children(Alter, C).
                        |  [ext],  husband(Ego, A), parents(B, A), generation[aux]27smallGS(C, B), daughter(D, C), husband(Alter, D).
                        |  [ext],  male(Ego), parents(A, Ego), generation[aux]27smallGS(B, A), daughter(C, B), husband(Alter, C).
;; 0
%nevu[aux]27:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 1
%nevu[aux]27:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), female(Alter).
;; 2
%nevu[aux]27:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), husband(Alter, D).
;; 3
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 4
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 5
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 6
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 7
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 8
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 9
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 10
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 11
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 12
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 13
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 14
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 15
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 16
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 17
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 18
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 19
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 20
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 21
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 22
%nevu[aux]27:2, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 23
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 24
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(Alter, E).
;; 25
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 26
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(Alter, E).
;; 27
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 28
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 29
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 30
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 31
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 32
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 33
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 34
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 35
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 36
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(Alter, G).
;; 37
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 38
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(Alter, G).
;; 39
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 40
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(Alter, G).
;; 41
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 42
%nevu[aux]27:2, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(Alter, G).
;; 43
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), husband(Alter, F).
;; 44
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), husband(Alter, F).
;; 45
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 46
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 47
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 48
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 49
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 50
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 51
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 52
%nevu[aux]27:3, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 53
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), husband(Alter, F).
;; 54
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), husband(Alter, F).
;; 55
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 56
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 57
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 58
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 59
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 60
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 61
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), husband(Alter, H).
;; 62
%nevu[aux]27:3, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  husband(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), husband(Alter, H).
;; 63
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), husband(Alter, E).
;; 64
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), husband(Alter, E).
;; 65
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 66
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 67
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 68
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 69
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 70
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 71
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 72
%nevu[aux]27:4, parents:0, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 73
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), husband(Alter, E).
;; 74
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), husband(Alter, E).
;; 75
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 76
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 77
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 78
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 79
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 80
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), husband(Alter, G).
;; 81
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), husband(Alter, G).
;; 82
%nevu[aux]27:4, parents:1, generation[aux]27smallGS:1, parents:1, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), husband(Alter, G).


oem(Alter, Ego) :-  husband(Alter, Ego).
{"Hu"}
;; 0
%oem:0%
 Lvl=0,  PC=0, S=1, Star=0,  {Hu}  
 husband(Alter, Ego).


owar(Alter, Ego) :-  wife(Alter, A), wife(Ego, A), not(equal(Alter, Ego)).
{"SoStmo"}
;; 0
%owar:0%
 Lvl=0,  PC=0, S=2, Star=0,  {SoStmo}  
 wife(Alter, A), wife(Ego, A), not(equal(Alter, Ego)).


parents(Alter, Ego) :-  mother(Alter, Ego).
                    |   father(Alter, Ego).
;; 0
%parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(Alter, Ego).
;; 1
%parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(Alter, Ego).


sibling(Alter, Ego) :-  mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 0
%sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).


siblings(Alter, Ego) :-  brother(Alter, Ego).
                     |   sister(Alter, Ego).
;; 0
%siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), male(Alter).
;; 1
%siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).


sister(Alter, Ego) :-  sibling(Alter, Ego), female(Alter).
;; 0
%sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)), female(Alter).


somu(Alter, Ego) :-  wife(Ego, A), brother(Alter, A).
                 |   male(Ego), sibling(A, Ego), wife(Alter, A).
                 |  [ext],  wife(Ego, A), sister(B, A), husband(Alter, B).
                 |  [ext],  wife(Ego, A), parents(B, A), generation[aux]27gs(C, B), son(Alter, C).
                 |  [ext],  wife(Ego, A), parents(B, A), generation[aux]27gs(C, B), child(D, C), husband(Alter, D).
                 |  [ext],  male(Ego), parents(A, Ego), generation[aux]27gs(B, A), son(C, B), wife(Alter, C).
{"BroWi_FaBroSoWi_FaFaBroDaSoWi_FaFaBroSoSoWi_FaFaFaBroDaDaSoWi_FaFaFaBroDaSoSoWi_FaFaFaBroSoDaSoWi_FaFaFaBroSoSoSoWi_FaFaFaSisDaDaSoWi_FaFaFaSisDaSoSoWi_FaFaFaSisSoDaSoWi_FaFaFaSisSoSoSoWi_FaFaMoBroDaDaSoWi_FaFaMoBroDaSoSoWi_FaFaMoBroSoDaSoWi_FaFaMoBroSoSoSoWi_FaFaMoSisDaDaSoWi_FaFaMoSisDaSoSoWi_FaFaMoSisSoDaSoWi_FaFaMoSisSoSoSoWi_FaFaSisDaSoWi_FaFaSisSoSoWi_FaMoBroDaSoWi_FaMoBroSoSoWi_FaMoFaBroDaDaSoWi_FaMoFaBroDaSoSoWi_FaMoFaBroSoDaSoWi_FaMoFaBroSoSoSoWi_FaMoFaSisDaDaSoWi_FaMoFaSisDaSoSoWi_FaMoFaSisSoDaSoWi_FaMoFaSisSoSoSoWi_FaMoMoBroDaDaSoWi_FaMoMoBroDaSoSoWi_FaMoMoBroSoDaSoWi_FaMoMoBroSoSoSoWi_FaMoMoSisDaDaSoWi_FaMoMoSisDaSoSoWi_FaMoMoSisSoDaSoWi_FaMoMoSisSoSoSoWi_FaMoSisDaSoWi_FaMoSisSoSoWi_FaSisSoWi_HuBro_HuFaBroDaHu_HuFaBroSo_HuFaFaBroDaDaHu_HuFaFaBroDaSo_HuFaFaBroSoDaHu_HuFaFaBroSoSo_HuFaFaSisDaDaHu_HuFaFaSisDaSo_HuFaFaSisSoDaHu_HuFaFaSisSoSo_HuFaMoBroDaDaHu_HuFaMoBroDaSo_HuFaMoBroSoDaHu_HuFaMoBroSoSo_HuFaMoSisDaDaHu_HuFaMoSisDaSo_HuFaMoSisSoDaHu_HuFaMoSisSoSo_HuFaSisDaHu_HuFaSisSo_HuMoBroDaHu_HuMoBroSo_HuMoFaBroDaDaHu_HuMoFaBroDaSo_HuMoFaBroSoDaHu_HuMoFaBroSoSo_HuMoFaSisDaDaHu_HuMoFaSisDaSo_HuMoFaSisSoDaHu_HuMoFaSisSoSo_HuMoMoBroDaDaHu_HuMoMoBroDaSo_HuMoMoBroSoDaHu_HuMoMoBroSoSo_HuMoMoSisDaDaHu_HuMoMoSisDaSo_HuMoMoSisSoDaHu_HuMoMoSisSoSo_HuMoSisDaHu_HuMoSisSo_HuSisHu_MoBroSoWi_MoFaBroDaSoWi_MoFaBroSoSoWi_MoFaFaBroDaDaSoWi_MoFaFaBroDaSoSoWi_MoFaFaBroSoDaSoWi_MoFaFaBroSoSoSoWi_MoFaFaSisDaDaSoWi_MoFaFaSisDaSoSoWi_MoFaFaSisSoDaSoWi_MoFaFaSisSoSoSoWi_MoFaMoBroDaDaSoWi_MoFaMoBroDaSoSoWi_MoFaMoBroSoDaSoWi_MoFaMoBroSoSoSoWi_MoFaMoSisDaDaSoWi_MoFaMoSisDaSoSoWi_MoFaMoSisSoDaSoWi_MoFaMoSisSoSoSoWi_MoFaSisDaSoWi_MoFaSisSoSoWi_MoMoBroDaSoWi_MoMoBroSoSoWi_MoMoFaBroDaDaSoWi_MoMoFaBroDaSoSoWi_MoMoFaBroSoDaSoWi_MoMoFaBroSoSoSoWi_MoMoFaSisDaDaSoWi_MoMoFaSisDaSoSoWi_MoMoFaSisSoDaSoWi_MoMoFaSisSoSoSoWi_MoMoMoBroDaDaSoWi_MoMoMoBroDaSoSoWi_MoMoMoBroSoDaSoWi_MoMoMoBroSoSoSoWi_MoMoMoSisDaDaSoWi_MoMoMoSisDaSoSoWi_MoMoMoSisSoDaSoWi_MoMoMoSisSoSoSoWi_MoMoSisDaSoWi_MoMoSisSoSoWi_MoSisSoWi"}
;; 0
%somu:0, brother:0, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {HuBro}  
 wife(Ego, A), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)), male(Alter).
;; 1
%somu:1, sibling:0%
 Lvl=0,  PC=4, S=1, Star=0,  {BroWi}  
 male(Ego), mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), wife(Alter, C).
;; 2
%somu:2, sister:0, sibling:0%
 Lvl=0,  PC=4, S=2, Star=0,  {HuSisHu}  
[ext],  wife(Ego, A), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), husband(Alter, D).
;; 3
%somu:3, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoBroSo}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 4
%somu:3, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuMoSisSo}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 5
%somu:3, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoBroSoSo}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 6
%somu:3, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoBroDaSo}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 7
%somu:3, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoSisSoSo}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 8
%somu:3, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoMoSisDaSo}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 9
%somu:3, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaBroSoSo}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 10
%somu:3, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaBroDaSo}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 11
%somu:3, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaSisSoSo}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 12
%somu:3, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuMoFaSisDaSo}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 13
%somu:3, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaBroSo}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(Alter, E).
;; 14
%somu:3, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {HuFaSisSo}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(Alter, E).
;; 15
%somu:3, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoBroSoSo}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 16
%somu:3, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoBroDaSo}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 17
%somu:3, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoSisSoSo}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 18
%somu:3, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaMoSisDaSo}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 19
%somu:3, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaBroSoSo}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(Alter, G).
;; 20
%somu:3, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaBroDaSo}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(Alter, G).
;; 21
%somu:3, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaSisSoSo}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(Alter, G).
;; 22
%somu:3, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {HuFaFaSisDaSo}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(Alter, G).
;; 23
%somu:4, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoBroDaHu}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(F, E), husband(Alter, F).
;; 24
%somu:4, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuMoSisDaHu}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(F, E), husband(Alter, F).
;; 25
%somu:4, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoBroSoDaHu}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(H, G), husband(Alter, H).
;; 26
%somu:4, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoBroDaDaHu}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 27
%somu:4, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoSisSoDaHu}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(H, G), husband(Alter, H).
;; 28
%somu:4, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoMoSisDaDaHu}  
[ext],  wife(Ego, A), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 29
%somu:4, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaBroSoDaHu}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(H, G), husband(Alter, H).
;; 30
%somu:4, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaBroDaDaHu}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 31
%somu:4, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaSisSoDaHu}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(H, G), husband(Alter, H).
;; 32
%somu:4, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuMoFaSisDaDaHu}  
[ext],  wife(Ego, A), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 33
%somu:4, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaBroDaHu}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(F, E), husband(Alter, F).
;; 34
%somu:4, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=2, Star=0,  {HuFaSisDaHu}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(F, E), husband(Alter, F).
;; 35
%somu:4, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoBroSoDaHu}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(H, G), husband(Alter, H).
;; 36
%somu:4, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoBroDaDaHu}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 37
%somu:4, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoSisSoDaHu}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(H, G), husband(Alter, H).
;; 38
%somu:4, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaMoSisDaDaHu}  
[ext],  wife(Ego, A), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 39
%somu:4, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaBroSoDaHu}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(H, G), husband(Alter, H).
;; 40
%somu:4, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaBroDaDaHu}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 41
%somu:4, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaSisSoDaHu}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(H, G), husband(Alter, H).
;; 42
%somu:4, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=2, Star=0,  {HuFaFaSisDaDaHu}  
[ext],  wife(Ego, A), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(H, G), husband(Alter, H).
;; 43
%somu:5, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoBroSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), wife(Alter, E).
;; 44
%somu:5, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {MoSisSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), wife(Alter, E).
;; 45
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), wife(Alter, G).
;; 46
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoBroDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 47
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), wife(Alter, G).
;; 48
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoMoSisDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 49
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoBroSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 50
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoBroSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 51
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoBroDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 52
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoBroDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 53
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoSisSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 54
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoSisSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 55
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoSisDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 56
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoMoSisDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 57
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaBroSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 58
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaBroSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 59
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaBroDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 60
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaBroDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 61
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaSisSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 62
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaSisSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 63
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaSisDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 64
%somu:5, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoMoFaSisDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 65
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), wife(Alter, G).
;; 66
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaBroDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 67
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), wife(Alter, G).
;; 68
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {MoFaSisDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 69
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoBroSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 70
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoBroSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 71
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoBroDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 72
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoBroDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 73
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoSisSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 74
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoSisSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 75
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoSisDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 76
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaMoSisDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 77
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaBroSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 78
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaBroSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 79
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaBroDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 80
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaBroDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 81
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaSisSoSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 82
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaSisSoDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 83
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaSisDaSoSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 84
%somu:5, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {MoFaFaSisDaDaSoWi}  
[ext],  male(Ego), mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 85
%somu:5, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaBroSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), wife(Alter, E).
;; 86
%somu:5, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=6, S=1, Star=0,  {FaSisSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), wife(Alter, E).
;; 87
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), wife(Alter, G).
;; 88
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoBroDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 89
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), wife(Alter, G).
;; 90
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaMoSisDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 91
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoBroSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 92
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoBroSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 93
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoBroDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 94
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoBroDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 95
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoSisSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 96
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoSisSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 97
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoSisDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 98
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoMoSisDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 99
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaBroSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 100
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaBroSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 101
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaBroDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 102
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaBroDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 103
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaSisSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 104
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaSisSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 105
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaSisDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 106
%somu:5, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaMoFaSisDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 107
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), wife(Alter, G).
;; 108
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaBroDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 109
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), wife(Alter, G).
;; 110
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=8, S=1, Star=0,  {FaFaSisDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), wife(Alter, G).
;; 111
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoBroSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 112
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoBroSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 113
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoBroDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 114
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoBroDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 115
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoSisSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 116
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoSisSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 117
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoSisDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 118
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaMoSisDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 119
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaBroSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 120
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaBroSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 121
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaBroDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 122
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaBroDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 123
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaSisSoSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 124
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaSisSoDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(I, H), wife(Alter, I).
;; 125
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaSisDaSoSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(I, H), wife(Alter, I).
;; 126
%somu:5, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=10, S=1, Star=0,  {FaFaFaSisDaDaSoWi}  
[ext],  male(Ego), father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(I, H), wife(Alter, I).


spice(Alter, Ego) :-  husband(Alter, Ego).
                  |   wife(Alter, Ego).
;; 0
%spice:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 husband(Alter, Ego).
;; 1
%spice:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 wife(Alter, Ego).


square[aux]27(Alter, Ego) :-  generation[aux]27(Alter, Ego).
                          |   parents(Alter, Ego).
                          |   parents(A, Ego), square[aux]27(Alter, A).
;; 0
%square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, Ego), child(Alter, A), child(Alter, B), not(equal(Alter, Ego)).
;; 1
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 2
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 3
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 4
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 5
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 6
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 7
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 8
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 9
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 10
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 11
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 12
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 13
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 14
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 15
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 16
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 17
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 18
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 19
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 20
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 21
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 22
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 23
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 24
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 25
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 26
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 27
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 28
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 29
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 30
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 31
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 32
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 33
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 34
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 35
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 36
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 37
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 38
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 39
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 40
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 41
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 42
%square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 43
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), child(Alter, D).
;; 44
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), child(Alter, D).
;; 45
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 46
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 47
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 48
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 49
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 50
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 51
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 52
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 53
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 54
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 55
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 56
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 57
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 58
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 59
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 60
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 61
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 62
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 63
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 64
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 65
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), child(Alter, F).
;; 66
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), child(Alter, F).
;; 67
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), child(Alter, F).
;; 68
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), child(Alter, F).
;; 69
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 70
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 71
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 72
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 73
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 74
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 75
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 76
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 77
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), child(Alter, H).
;; 78
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), child(Alter, H).
;; 79
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), child(Alter, H).
;; 80
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 81
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), child(Alter, H).
;; 82
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), child(Alter, H).
;; 83
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), child(Alter, H).
;; 84
%square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), child(Alter, H).
;; 85
%square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(Alter, Ego).
;; 86
%square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(Alter, Ego).
;; 87
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 88
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 89
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 90
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 91
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 92
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 93
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 94
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 95
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 96
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 97
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 98
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 99
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 100
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 101
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 102
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 103
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 104
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 105
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 106
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 107
%square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 108
%square[aux]27:2, parents:0, square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(Alter, A).
;; 109
%square[aux]27:2, parents:0, square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(Alter, A).
;; 110
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 111
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 112
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 113
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 114
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 115
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 116
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 117
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 118
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 119
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 120
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 121
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 122
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 123
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 124
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 125
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 126
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 127
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 128
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 129
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 130
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 131
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), mother(Alter, B).
;; 132
%square[aux]27:2, parents:0, square[aux]27:2, parents:0, square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), mother(B, A), father(Alter, B).
;; 133
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 134
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 135
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 136
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 137
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 138
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 139
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 140
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 141
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 142
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 143
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 144
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 145
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 146
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 147
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 148
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 149
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 150
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 151
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 152
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 153
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 154
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), mother(Alter, B).
;; 155
%square[aux]27:2, parents:0, square[aux]27:2, parents:1, square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 mother(A, Ego), father(B, A), father(Alter, B).
;; 156
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, A), child(Alter, B), child(Alter, C), not(equal(Alter, A)).
;; 157
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 158
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 159
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 160
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 161
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 162
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 163
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 164
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 165
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 166
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 167
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), child(Alter, E).
;; 168
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), child(Alter, E).
;; 169
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 170
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 171
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 172
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 173
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), child(Alter, G).
;; 174
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), child(Alter, G).
;; 175
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), child(Alter, G).
;; 176
%square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), child(Alter, G).
;; 177
%square[aux]27:2, parents:1, square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(Alter, A).
;; 178
%square[aux]27:2, parents:1, square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(Alter, A).
;; 179
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 180
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 181
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 182
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 183
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 184
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 185
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 186
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 187
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 188
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 189
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 190
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 191
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 192
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 193
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 194
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 195
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 196
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 197
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 198
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 199
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 200
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), mother(Alter, B).
;; 201
%square[aux]27:2, parents:1, square[aux]27:2, parents:0, square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, A), father(Alter, B).
;; 202
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, B), child(Alter, C), child(Alter, D), not(equal(Alter, B)).
;; 203
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 204
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 205
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 206
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 207
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 208
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 209
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 210
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 211
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 212
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 213
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), child(Alter, F).
;; 214
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), child(Alter, F).
;; 215
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 216
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 217
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 218
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), mother(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 219
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), son(H, G), child(Alter, H).
;; 220
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), male(G), daughter(H, G), child(Alter, H).
;; 221
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), son(H, G), child(Alter, H).
;; 222
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:0, generation[aux]27:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(C, B), father(D, C), mother(E, D), father(F, D), child(G, E), child(G, F), not(equal(G, D)), female(G), daughter(H, G), child(Alter, H).
;; 223
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:1, parents:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), mother(Alter, B).
;; 224
%square[aux]27:2, parents:1, square[aux]27:2, parents:1, square[aux]27:1, parents:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), father(B, A), father(Alter, B).


step_brother(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), son(Alter, D), son(Alter, C).
                         |   father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), son(Alter, D), son(Alter, C).
;; 0
%step_brother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), son(Alter, D), son(Alter, C).
;; 1
%step_brother:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), son(Alter, D), son(Alter, C).


step_daughter(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).
;; 0
%step_daughter:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).


step_father(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).
;; 0
%step_father:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(Alter, B), not(equal(Alter, A)).


step_mother(Alter, Ego) :-  father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).
;; 0
%step_mother:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(Alter, A), not(equal(Alter, B)).


step_sister(Alter, Ego) :-  father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), daughter(Alter, D), daughter(Alter, C).
                        |   father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), daughter(Alter, D), daughter(Alter, C).
;; 0
%step_sister:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), husband(C, B), not(equal(C, A)), wife(D, C), not(equal(D, B)), daughter(Alter, D), daughter(Alter, C).
;; 1
%step_sister:1%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 father(A, Ego), mother(B, Ego), wife(C, A), not(equal(C, B)), husband(D, C), not(equal(D, A)), daughter(Alter, D), daughter(Alter, C).


step_son(Alter, Ego) :-  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).
;; 0
%step_son:0%
 Lvl=0,  PC=0, S=0, Star=0,  {None}  
 spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).


tato(Alter, Ego) :-  children(Alter, Ego).
                 |  [ext],  generation[aux]27gs(A, Ego), children(Alter, A).
                 |  [ext],  step_son(Alter, Ego).
                 |  [ext],  step_daughter(Alter, Ego).
                 |  [ext],  spice(A, Ego), generation[aux]27gs(B, A), children(Alter, B).
{"BroDa_BroSo_Da_FaBroDaDa_FaBroDaSo_FaBroSoDa_FaBroSoSo_FaFaBroDaDaDa_FaFaBroDaDaSo_FaFaBroDaSoDa_FaFaBroDaSoSo_FaFaBroSoDaDa_FaFaBroSoDaSo_FaFaBroSoSoDa_FaFaBroSoSoSo_FaFaSisDaDaDa_FaFaSisDaDaSo_FaFaSisDaSoDa_FaFaSisDaSoSo_FaFaSisSoDaDa_FaFaSisSoDaSo_FaFaSisSoSoDa_FaFaSisSoSoSo_FaMoBroDaDaDa_FaMoBroDaDaSo_FaMoBroDaSoDa_FaMoBroDaSoSo_FaMoBroSoDaDa_FaMoBroSoDaSo_FaMoBroSoSoDa_FaMoBroSoSoSo_FaMoSisDaDaDa_FaMoSisDaDaSo_FaMoSisDaSoDa_FaMoSisDaSoSo_FaMoSisSoDaDa_FaMoSisSoDaSo_FaMoSisSoSoDa_FaMoSisSoSoSo_FaSisDaDa_FaSisDaSo_FaSisSoDa_FaSisSoSo_HuBroDa_HuBroSo_HuFaBroDaDa_HuFaBroDaSo_HuFaBroSoDa_HuFaBroSoSo_HuFaFaBroDaDaDa_HuFaFaBroDaDaSo_HuFaFaBroDaSoDa_HuFaFaBroDaSoSo_HuFaFaBroSoDaDa_HuFaFaBroSoDaSo_HuFaFaBroSoSoDa_HuFaFaBroSoSoSo_HuFaFaSisDaDaDa_HuFaFaSisDaDaSo_HuFaFaSisDaSoDa_HuFaFaSisDaSoSo_HuFaFaSisSoDaDa_HuFaFaSisSoDaSo_HuFaFaSisSoSoDa_HuFaFaSisSoSoSo_HuFaMoBroDaDaDa_HuFaMoBroDaDaSo_HuFaMoBroDaSoDa_HuFaMoBroDaSoSo_HuFaMoBroSoDaDa_HuFaMoBroSoDaSo_HuFaMoBroSoSoDa_HuFaMoBroSoSoSo_HuFaMoSisDaDaDa_HuFaMoSisDaDaSo_HuFaMoSisDaSoDa_HuFaMoSisDaSoSo_HuFaMoSisSoDaDa_HuFaMoSisSoDaSo_HuFaMoSisSoSoDa_HuFaMoSisSoSoSo_HuFaSisDaDa_HuFaSisDaSo_HuFaSisSoDa_HuFaSisSoSo_HuMoBroDaDa_HuMoBroDaSo_HuMoBroSoDa_HuMoBroSoSo_HuMoFaBroDaDaDa_HuMoFaBroDaDaSo_HuMoFaBroDaSoDa_HuMoFaBroDaSoSo_HuMoFaBroSoDaDa_HuMoFaBroSoDaSo_HuMoFaBroSoSoDa_HuMoFaBroSoSoSo_HuMoFaSisDaDaDa_HuMoFaSisDaDaSo_HuMoFaSisDaSoDa_HuMoFaSisDaSoSo_HuMoFaSisSoDaDa_HuMoFaSisSoDaSo_HuMoFaSisSoSoDa_HuMoFaSisSoSoSo_HuMoMoBroDaDaDa_HuMoMoBroDaDaSo_HuMoMoBroDaSoDa_HuMoMoBroDaSoSo_HuMoMoBroSoDaDa_HuMoMoBroSoDaSo_HuMoMoBroSoSoDa_HuMoMoBroSoSoSo_HuMoMoSisDaDaDa_HuMoMoSisDaDaSo_HuMoMoSisDaSoDa_HuMoMoSisDaSoSo_HuMoMoSisSoDaDa_HuMoMoSisSoDaSo_HuMoMoSisSoSoDa_HuMoMoSisSoSoSo_HuMoSisDaDa_HuMoSisDaSo_HuMoSisSoDa_HuMoSisSoSo_HuSisDa_HuSisSo_MoBroDaDa_MoBroDaSo_MoBroSoDa_MoBroSoSo_MoFaBroDaDaDa_MoFaBroDaDaSo_MoFaBroDaSoDa_MoFaBroDaSoSo_MoFaBroSoDaDa_MoFaBroSoDaSo_MoFaBroSoSoDa_MoFaBroSoSoSo_MoFaSisDaDaDa_MoFaSisDaDaSo_MoFaSisDaSoDa_MoFaSisDaSoSo_MoFaSisSoDaDa_MoFaSisSoDaSo_MoFaSisSoSoDa_MoFaSisSoSoSo_MoMoBroDaDaDa_MoMoBroDaDaSo_MoMoBroDaSoDa_MoMoBroDaSoSo_MoMoBroSoDaDa_MoMoBroSoDaSo_MoMoBroSoSoDa_MoMoBroSoSoSo_MoMoSisDaDaDa_MoMoSisDaDaSo_MoMoSisDaSoDa_MoMoSisDaSoSo_MoMoSisSoDaDa_MoMoSisSoDaSo_MoMoSisSoSoDa_MoMoSisSoSoSo_MoSisDaDa_MoSisDaSo_MoSisSoDa_MoSisSoSo_SisDa_SisSo_So_Stda_Stso_WiBroDa_WiBroSo_WiFaBroDaDa_WiFaBroDaSo_WiFaBroSoDa_WiFaBroSoSo_WiFaFaBroDaDaDa_WiFaFaBroDaDaSo_WiFaFaBroDaSoDa_WiFaFaBroDaSoSo_WiFaFaBroSoDaDa_WiFaFaBroSoDaSo_WiFaFaBroSoSoDa_WiFaFaBroSoSoSo_WiFaFaSisDaDaDa_WiFaFaSisDaDaSo_WiFaFaSisDaSoDa_WiFaFaSisDaSoSo_WiFaFaSisSoDaDa_WiFaFaSisSoDaSo_WiFaFaSisSoSoDa_WiFaFaSisSoSoSo_WiFaMoBroDaDaDa_WiFaMoBroDaDaSo_WiFaMoBroDaSoDa_WiFaMoBroDaSoSo_WiFaMoBroSoDaDa_WiFaMoBroSoDaSo_WiFaMoBroSoSoDa_WiFaMoBroSoSoSo_WiFaMoSisDaDaDa_WiFaMoSisDaDaSo_WiFaMoSisDaSoDa_WiFaMoSisDaSoSo_WiFaMoSisSoDaDa_WiFaMoSisSoDaSo_WiFaMoSisSoSoDa_WiFaMoSisSoSoSo_WiFaSisDaDa_WiFaSisDaSo_WiFaSisSoDa_WiFaSisSoSo_WiMoBroDaDa_WiMoBroDaSo_WiMoBroSoDa_WiMoBroSoSo_WiMoFaBroDaDaDa_WiMoFaBroDaDaSo_WiMoFaBroDaSoDa_WiMoFaBroDaSoSo_WiMoFaBroSoDaDa_WiMoFaBroSoDaSo_WiMoFaBroSoSoDa_WiMoFaBroSoSoSo_WiMoFaSisDaDaDa_WiMoFaSisDaDaSo_WiMoFaSisDaSoDa_WiMoFaSisDaSoSo_WiMoFaSisSoDaDa_WiMoFaSisSoDaSo_WiMoFaSisSoSoDa_WiMoFaSisSoSoSo_WiMoMoBroDaDaDa_WiMoMoBroDaDaSo_WiMoMoBroDaSoDa_WiMoMoBroDaSoSo_WiMoMoBroSoDaDa_WiMoMoBroSoDaSo_WiMoMoBroSoSoDa_WiMoMoBroSoSoSo_WiMoMoSisDaDaDa_WiMoMoSisDaDaSo_WiMoMoSisDaSoDa_WiMoMoSisDaSoSo_WiMoMoSisSoDaDa_WiMoMoSisSoDaSo_WiMoMoSisSoSoDa_WiMoMoSisSoSoSo_WiMoSisDaDa_WiMoSisDaSo_WiMoSisSoDa_WiMoSisSoSo_WiSisDa_WiSisSo"}
;; 0
%tato:0, children:0%
 Lvl=-1,  PC=1, S=0, Star=0,  {So}  
 son(Alter, Ego).
;; 1
%tato:0, children:1%
 Lvl=-1,  PC=1, S=0, Star=0,  {Da}  
 daughter(Alter, Ego).
;; 2
%tato:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {BroSo}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), son(Alter, C).
;; 3
%tato:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=5, S=0, Star=0,  {BroDa}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), male(C), daughter(Alter, C).
;; 4
%tato:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=5, S=0, Star=0,  {SisSo}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), son(Alter, C).
;; 5
%tato:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=5, S=0, Star=0,  {SisDa}  
[ext],  mother(A, Ego), father(B, Ego), child(C, A), child(C, B), not(equal(C, Ego)), female(C), daughter(Alter, C).
;; 6
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(Alter, E).
;; 7
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(Alter, E).
;; 8
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(Alter, E).
;; 9
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoBroDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(Alter, E).
;; 10
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisSoSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(Alter, E).
;; 11
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisSoDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(Alter, E).
;; 12
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisDaSo}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(Alter, E).
;; 13
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {MoSisDaDa}  
[ext],  mother(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(Alter, E).
;; 14
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(Alter, G).
;; 15
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(Alter, G).
;; 16
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(Alter, G).
;; 17
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 18
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(Alter, G).
;; 19
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 20
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 21
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoBroDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 22
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(Alter, G).
;; 23
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(Alter, G).
;; 24
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(Alter, G).
;; 25
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisSoDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 26
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaSoSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(Alter, G).
;; 27
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaSoDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 28
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaDaSo}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 29
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoMoSisDaDaDa}  
[ext],  mother(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 30
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(Alter, G).
;; 31
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(Alter, G).
;; 32
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(Alter, G).
;; 33
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroSoDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 34
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(Alter, G).
;; 35
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 36
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 37
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaBroDaDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 38
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(Alter, G).
;; 39
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(Alter, G).
;; 40
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(Alter, G).
;; 41
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisSoDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 42
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaSoSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(Alter, G).
;; 43
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaSoDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 44
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaDaSo}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 45
%tato:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {MoFaSisDaDaDa}  
[ext],  mother(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 46
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), son(Alter, E).
;; 47
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(E, D), daughter(Alter, E).
;; 48
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), son(Alter, E).
;; 49
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaBroDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(E, D), daughter(Alter, E).
;; 50
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisSoSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), son(Alter, E).
;; 51
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisSoDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(E, D), daughter(Alter, E).
;; 52
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisDaSo}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), son(Alter, E).
;; 53
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=0, Star=0,  {FaSisDaDa}  
[ext],  father(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(E, D), daughter(Alter, E).
;; 54
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(Alter, G).
;; 55
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(Alter, G).
;; 56
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(Alter, G).
;; 57
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroSoDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 58
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(Alter, G).
;; 59
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 60
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 61
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoBroDaDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 62
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(Alter, G).
;; 63
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(Alter, G).
;; 64
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(Alter, G).
;; 65
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisSoDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 66
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaSoSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(Alter, G).
;; 67
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaSoDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 68
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaDaSo}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 69
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaMoSisDaDaDa}  
[ext],  father(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 70
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), son(Alter, G).
;; 71
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(G, F), daughter(Alter, G).
;; 72
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), son(Alter, G).
;; 73
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroSoDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 74
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), son(Alter, G).
;; 75
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 76
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 77
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaBroDaDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 78
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), son(Alter, G).
;; 79
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(G, F), daughter(Alter, G).
;; 80
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), son(Alter, G).
;; 81
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisSoDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(G, F), daughter(Alter, G).
;; 82
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaSoSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), son(Alter, G).
;; 83
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaSoDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(G, F), daughter(Alter, G).
;; 84
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaDaSo}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), son(Alter, G).
;; 85
%tato:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=0, Star=0,  {FaFaSisDaDaDa}  
[ext],  father(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(G, F), daughter(Alter, G).
;; 86
%tato:2, step_son:0%
 Lvl=-1,  PC=2, S=2, Star=0,  {Stso}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), son(Alter, B), son(Alter, A).
;; 87
%tato:3, step_daughter:0%
 Lvl=-1,  PC=2, S=2, Star=0,  {Stda}  
[ext],  spouse(A, Ego), spouse(B, A), not(equal(Ego, B)), daughter(Alter, B), daughter(Alter, A).
;; 88
%tato:4, spice:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuBroSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 89
%tato:4, spice:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuBroDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 90
%tato:4, spice:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuSisSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 91
%tato:4, spice:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=5, S=1, Star=0,  {HuSisDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 92
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroSoSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 93
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroSoDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 94
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroDaSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 95
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoBroDaDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 96
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisSoSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 97
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisSoDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 98
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisDaSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 99
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuMoSisDaDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 100
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroSoSoSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 101
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroSoSoDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 102
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroSoDaSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 103
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroSoDaDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 104
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroDaSoSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 105
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroDaSoDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 106
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroDaDaSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 107
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoBroDaDaDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 108
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisSoSoSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 109
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisSoSoDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 110
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisSoDaSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 111
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisSoDaDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 112
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisDaSoSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 113
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisDaSoDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 114
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisDaDaSo}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 115
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoMoSisDaDaDa}  
[ext],  husband(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 116
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroSoSoSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 117
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroSoSoDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 118
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroSoDaSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 119
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroSoDaDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 120
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroDaSoSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 121
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroDaSoDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 122
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroDaDaSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 123
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaBroDaDaDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 124
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisSoSoSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 125
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisSoSoDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 126
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisSoDaSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 127
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisSoDaDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 128
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisDaSoSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 129
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisDaSoDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 130
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisDaDaSo}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 131
%tato:4, spice:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuMoFaSisDaDaDa}  
[ext],  husband(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 132
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroSoSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 133
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroSoDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 134
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroDaSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 135
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaBroDaDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 136
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisSoSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 137
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisSoDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 138
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisDaSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 139
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {HuFaSisDaDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 140
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroSoSoSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 141
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroSoSoDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 142
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroSoDaSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 143
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroSoDaDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 144
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroDaSoSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 145
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroDaSoDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 146
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroDaDaSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 147
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoBroDaDaDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 148
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisSoSoSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 149
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisSoSoDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 150
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisSoDaSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 151
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisSoDaDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 152
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisDaSoSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 153
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisDaSoDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 154
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisDaDaSo}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 155
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaMoSisDaDaDa}  
[ext],  husband(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 156
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroSoSoSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 157
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroSoSoDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 158
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroSoDaSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 159
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroSoDaDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 160
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroDaSoSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 161
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroDaSoDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 162
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroDaDaSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 163
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaBroDaDaDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 164
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisSoSoSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 165
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisSoSoDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 166
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisSoDaSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 167
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisSoDaDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 168
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisDaSoSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 169
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisDaSoDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 170
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisDaDaSo}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 171
%tato:4, spice:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {HuFaFaSisDaDaDa}  
[ext],  husband(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 172
%tato:4, spice:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiBroSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), son(Alter, D).
;; 173
%tato:4, spice:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiBroDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), male(D), daughter(Alter, D).
;; 174
%tato:4, spice:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiSisSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), son(Alter, D).
;; 175
%tato:4, spice:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1%
 Lvl=-1,  PC=5, S=1, Star=0,  {WiSisDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, A), child(D, B), child(D, C), not(equal(D, A)), female(D), daughter(Alter, D).
;; 176
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroSoSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 177
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroSoDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 178
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroDaSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 179
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoBroDaDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 180
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisSoSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 181
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisSoDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 182
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisDaSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 183
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiMoSisDaDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 184
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroSoSoSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 185
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroSoSoDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 186
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroSoDaSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 187
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroSoDaDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 188
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroDaSoSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 189
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroDaSoDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 190
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroDaDaSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 191
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoBroDaDaDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 192
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisSoSoSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 193
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisSoSoDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 194
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisSoDaSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 195
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisSoDaDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 196
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisDaSoSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 197
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisDaSoDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 198
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisDaDaSo}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 199
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoMoSisDaDaDa}  
[ext],  wife(A, Ego), mother(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 200
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroSoSoSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 201
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroSoSoDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 202
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroSoDaSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 203
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroSoDaDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 204
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroDaSoSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 205
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroDaSoDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 206
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroDaDaSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 207
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaBroDaDaDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 208
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisSoSoSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 209
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisSoSoDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 210
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisSoDaSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 211
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisSoDaDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 212
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisDaSoSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 213
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisDaSoDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 214
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisDaDaSo}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 215
%tato:4, spice:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiMoFaSisDaDaDa}  
[ext],  wife(A, Ego), mother(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 216
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroSoSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), son(Alter, F).
;; 217
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroSoDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), son(F, E), daughter(Alter, F).
;; 218
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroDaSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), son(Alter, F).
;; 219
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaBroDaDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), male(E), daughter(F, E), daughter(Alter, F).
;; 220
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisSoSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), son(Alter, F).
;; 221
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisSoDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), son(F, E), daughter(Alter, F).
;; 222
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisDaSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), son(Alter, F).
;; 223
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1%
 Lvl=-1,  PC=7, S=1, Star=0,  {WiFaSisDaDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), father(D, B), child(E, C), child(E, D), not(equal(E, B)), female(E), daughter(F, E), daughter(Alter, F).
;; 224
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroSoSoSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 225
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroSoSoDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 226
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroSoDaSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 227
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroSoDaDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 228
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroDaSoSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 229
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroDaSoDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 230
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroDaDaSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 231
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoBroDaDaDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 232
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisSoSoSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 233
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisSoSoDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 234
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisSoDaSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 235
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisSoDaDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 236
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisDaSoSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 237
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisDaSoDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 238
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisDaDaSo}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 239
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:0, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaMoSisDaDaDa}  
[ext],  wife(A, Ego), father(B, A), mother(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 240
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroSoSoSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), son(Alter, H).
;; 241
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroSoSoDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), son(H, G), daughter(Alter, H).
;; 242
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroSoDaSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), son(Alter, H).
;; 243
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroSoDaDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 244
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroDaSoSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), son(Alter, H).
;; 245
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroDaSoDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 246
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroDaDaSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 247
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:0, brother:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaBroDaDaDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), male(F), daughter(G, F), daughter(H, G), daughter(Alter, H).
;; 248
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisSoSoSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), son(Alter, H).
;; 249
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisSoSoDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), son(H, G), daughter(Alter, H).
;; 250
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisSoDaSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), son(Alter, H).
;; 251
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:0, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisSoDaDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), son(G, F), daughter(H, G), daughter(Alter, H).
;; 252
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisDaSoSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), son(Alter, H).
;; 253
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:0, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisDaSoDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), son(H, G), daughter(Alter, H).
;; 254
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:0%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisDaDaSo}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), son(Alter, H).
;; 255
%tato:4, spice:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:1, parents:1, generation[aux]27gs:0, siblings:1, sister:0, sibling:0, children:1, children:1, children:1%
 Lvl=-1,  PC=9, S=1, Star=0,  {WiFaFaSisDaDaDa}  
[ext],  wife(A, Ego), father(B, A), father(C, B), mother(D, C), father(E, C), child(F, D), child(F, E), not(equal(F, C)), female(F), daughter(G, F), daughter(H, G), daughter(Alter, H).

